# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.96
sigma_e = np.array([0.0,0.])
sigma_E = np.eye(3)
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.65
rho_Theta=0.8
delta = 0.
ineq = 1.
epsilonbar = 6.
BarTheta = 0.00
BTarget = 0.9
TauTarget = 0.24
TaubTarget = 0.0
TaudTarget = 0.0
a_taylor = 1/beta - 1
b_taylor = 2.5


e_vec = None
f_vec = None


k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 1 # number of measurability constraints
nG = 1 # number of aggregate measurability constraints.
ny = 23 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 4 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 18 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 4 # Number of individual states (m_{t-1},mu_{t-1})
nv = 4 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 2
neps = len(sigma_e)
nEps = 3


phat = np.array([-0.00])

y_labels = 'logm,e,s_i,ebar_i,c,n,ucP,w_e,b,pihat,phillips,nu,u,v,lwe,ly,fi,de,b_,x_,Epihat_,alpha1_,Ev_ '.split(',')
Y_labels = 'Eps_ThetaAR,Eps_MU,Alpha1_,Alpha2,T,Pi,What,Y,B,W,D,Tau,i,UC,V,N,lYN,W_e'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm,e,s_i,ebar_i,c,nl,ucP,w_e,b,pihat,phillips,nu,u,v,lwe,ly,fi,de,b_,x_,Epihat_,alpha1_,Ev_ = w[:ny] #y
    EucP,Ex_,Epihat,Evhat = w[ny:ny+ne] #e
    Eps_ThetaAR,Eps_MU,Alpha1_,Alpha2,T,Pi,What,Y,B,W,D,Tau,i,UC,V,N,lYN,W_e = w[ny+ne:ny+ne+nY] #Y
    logm_,e_,s_i_,ebar_i_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,Epihatprime,alpha1,Evprime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_ThetaAR_,Eps_MU_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2,Eps_tfp_ar = w[ny+ne+nY+nz+nv+n_p+nZ+neps:] #aggregate shockaggregate shock
    
    m_,m = np.exp(logm_),np.exp(logm)
    E_Theta = BarTheta + Eps
    epsilon = epsilonbar*np.exp(Eps_MU)
    
    f_i = E(e_+ebar_i_)
    
    uc = c**(-sigma)
    un = -nl**(gamma)
    P = 1. /(1+Pi)*np.exp(-sigma*E_Theta)
    P=P*(1-TaubTarget)
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0] = x_ - Ex_ # x is independent of shocks
 
    ret[1] = x_*uc*P*np.exp((sigma-1)*E_Theta)/(beta*EucP) - uc*(c-T-(1-TaudTarget)*D*s_i) - un*nl - x #impl
    ret[2] = Alpha2 - m*uc #defines m
    ret[3] = What*w_e*uc + un #wage
    ret[4] = e - rho_e*e_ - eps_p# - (f_i)*ineq*(Eps+Eps_tfp_ar)#- (0.5-i)*ineq_slope*Eps
    ret[5] = w_e - np.exp(e+eps_t+ebar_i+(1+ineq*f_i)*Eps_ThetaAR)
    ret[6] = ucP - uc*P
    ret[7] = b - x/uc
    ret[8] = b_ - x_*m_
    ret[9] = pihat - UC*Pi*(1+Pi)*np.exp((1-sigma)*E_Theta)*psi
    ret[10] = Epihat_ - Epihat
    ret[11] = phillips + UC*Pi*(1+Pi)*psi - beta*Epihatprime -UC*Y*(1-epsilon*(1-W))
    ret[12] = alpha1_-Alpha1_
    ret[13] = nu-alpha1
    ret[14] = v- (u+beta*Evprime)*np.exp((1-sigma)*E_Theta)
    ret[15] = Ev_ - Evhat
    ret[16] = s_i - s_i_
    ret[17] = u -utility(c,nl)
    ret[18] = ebar_i - ebar_i_
    ret[19] = lwe - (e+eps_t+ebar_i+Eps_ThetaAR)#+(1+ineq*f_i)*Eps_ThetaAR)
    ret[20] = ly - lwe - np.log(nl)
    ret[21] = fi - f_i*Eps_tfp_ar
    ret[22] = de - (rho_e - 1)*e_ - eps_p 
    
    ret[23] = Alpha1_ - m_*EucP # bond pricing
    
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm,e,s_i,ebar_i,c,nl,ucP,w_e,b,pihat,phillips,nu,u,v,lwe,ly,fi,de,b_,x_,Epihat_,alpha1_,Ev_ = w[:ny] #y
    Eps_ThetaAR,Eps_MU,Alpha1_,Alpha2,T,Pi,What,Y,B,W,D,Tau,i,UC,V,N,lYN,W_e = w[ny+ne:ny+ne+nY] #Y
    Eps_ThetaAR_,Eps_MU_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2,Eps_tfp_ar = w[ny+ne+nY+nz+nv+n_p+nZ+neps:] #aggregate shockaggregate shock
 
    m = np.exp(logm)
    uc = c**(-sigma)
    
    epsilon = epsilonbar*np.exp(Eps_MU)
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = Alpha1_ #alpha_1 can't depend on Eps  
    
    ret[1] = logm #normalizing for Em=1
    ret[2] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[3] = Eps_MU - rho_MU*Eps_MU_ - Eps2
    ret[4] = Eps_ThetaAR- rho_Theta*Eps_ThetaAR_ - Eps_tfp_ar 
    ret[5] = Y - w_e*nl
    ret[6] = B - b
    ret[7] = phillips
    ret[8] = D - ((1-W)*Y-0.5*psi*Pi**2)
    ret[9] = (1-Tau)*W - What
    ret[10] = Tau-TauTarget 
    ret[11] = 1+i - Alpha2/(beta*nu)
    ret[12] = i - (a_taylor + b_taylor*Pi) 
    #ret[12] = Pi 
    ret[13] = V-Ev_
    ret[14] = UC- s_i*uc
    ret[15] = N - nl
    ret[16] = np.log(Y/N) - lYN
    ret[17] = W_e - w_e
    
    ret[18] = b_ # normalize average transfers to zero note doesn't depend on Eps here
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm,e,s_i,ebar_i,c,nl,ucP,w_e,b,pihat,phillips,nu,u,v,lwe,ly,fi,de,b_,x_,Epihat_,alpha1_,Ev_= y
  
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucP
    ret[1] = x_
    ret[2] = pihat
    ret[3] = v
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm,e,s_i,ebar_i = z
    Eps_ThetaAR,Eps_MU,Alpha1_,Alpha2,T,Pi,What,Y,B,W,D,Tau,i,UC,V,N,lYN,W_e = YSS
    
    epsilon=epsilonbar
    m = np.exp(logm)
    
    w_e = np.exp(e+ebar_i)
    Uc =Alpha2/m
    c = Uc**(-1/sigma) 
    Un = -What*Uc*w_e
    nl = (-Un)**(1/gamma)
    
    x = ( Uc*(c-T-(1-TaudTarget)*D*s_i) + Un*nl )/(1./beta-1)
    
    ucP = Uc*(1+Pi)**(-1)
    
    
    b = x/Uc
    b_ = x*m
    
    pihat = UC*Pi*(1+Pi)*psi*np.ones(logm.shape)
    phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
    alpha1_ = Alpha1_*np.ones(logm.shape)
    nu = alpha1_
    
    u = utility(c,nl)
    v = u/(1-beta)
    lwe = e + ebar_i
    ly = lwe + np.log(nl)
    fi = 0.*lwe
    de = fi
    #logm,e,p,c,nl,ucP,w_e,b,pihat,phillips,nu,b_,x_,Epihat_,alpha1_
    return np.vstack((
    logm,e,s_i,ebar_i,c,nl,ucP,w_e,b,pihat,phillips,alpha1_,u,v,lwe,ly,fi,de,b_,x,pihat,alpha1_,v
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logm,e,s_i,ebar_i,c,nl,ucP,w_e,b,pihat,phillips,nu,u,v,lwe,ly,fi,de,b_,x_,Epihat_,alpha1_,Ev_ = y_i
    Eps_ThetaAR,Eps_MU,Alpha1,Alpha2,T,Pi,What,Y,B,W,D,Tau,i,UC,V,N,lYN,W_e= YSS

    uc = c**(-sigma)
    return np.hstack([
    Alpha1*(1+Pi)-Alpha2,
    B,
    Eps_MU,
    Eps_ThetaAR,
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),
    weights.dot(Y-(w_e*nl)),
    weights.dot(B-b),
    weights.dot(phillips),
    D - ((1-W)*Y-0.5*psi*Pi**2),
    (1-Tau)*W - What,
    Tau-TauTarget,
    Pi,
    1+i - Alpha2/(beta*Alpha1),
    weights.dot(V-v),
    weights.dot(UC-s_i*uc),
    weights.dot(N - nl),
    lYN - np.log(Y/N),
    weights.dot(W_e-w_e)
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    #if (YSS[3] > 1.) | (YSS[3] < -.1):
    return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''          
    if weights is None:
        Gamma[:,0] -= np.mean(Gamma[:,0]) 
    else:
        Gamma[:,0] -= weights.dot(Gamma[:,0])
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    