# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.4])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
epsilonbar = 6.
BarTheta=0.
ar = 0.

omega_vec = None
s_vec = None

k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 2 # number of measurability constraints
nG = 2 # number of aggregate measurability constraints.
ny = 23 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 5 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 18 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 5 # Number of individual states (m_{t-1},mu_{t-1})
nv = 4 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 2
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logm,muhat,omega,e,s_i,c,n,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,i,b_,x_,kappa_,Epihat_,EucP_ '.split(',')
Y_labels = 'Eps_MU,Eps_Theta,Alpha1_,Alpha2,Tr,Pi,W,Tau,Lambda,Y,B,UC,Nu,Chi,Xi,D,S,I'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,i,b_,x_,kappa_,Epihat_,EucP_ = w[:ny] #y
    EucP,EucPmu,Ex_,Erho1_,Epihat = w[ny:ny+ne] #e
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Lambda,Y,B,UC,Nu,Chi,Xi,D,S,I = w[ny+ne:ny+ne+nY] #Y
    logm_,muhat_,omega_,e_,s_i_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,kappa,Epihatprime,EucPprime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_MU_,Eps_Theta_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    m_,m = np.exp(logm_),np.exp(logm)
    mu_ = muhat_ * m_
    mu = muhat * m    
    E_Theta = (1-ar)*(BarTheta + Eps)
    epsilon = epsilonbar*np.exp(Eps_MU)
    
    f_i = E(e_)
    
    uc = c**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unn = -gamma*nl**(gamma-1)
    P = 1. /(1+Pi)*np.exp(-sigma*E_Theta)
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0] = mu - mu_ # x is independent of shocks
    ret[1] = m - m_   #rho1_ is independent of shocks
     
    ret[2] = x_*ucP*np.exp((sigma-1)*E_Theta)/(beta*EucP) - uc*(c-T-D*s_i) - un*nl - x #impl
    ret[3] = Alpha2 - m*uc #defines m
    ret[4] = (1-Tau)*W*w_e*uc + un #wage
    ret[5] = np.exp((1-sigma)*E_Theta)*omega*un - mu*np.exp((1-sigma)*E_Theta)*(unn*nl + un) + phi*unn + Xi*w_e
    ret[6] = rho1_ - m_*EucP
    ret[7] = (np.exp((1-sigma)*E_Theta)*omega*uc  - np.exp((1-sigma)*E_Theta)*mu*(ucc*(c-T-s_i*D) + uc)
                +np.exp((1-sigma)*E_Theta)*rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda)
    ret[8] = kappa_ - rho1_*EucP
    ret[9] = e - rho_e*e_ - eps_p#0.5*((f_i)*Eps - f_i*(Eps**2)/0.0225)*ineq#- (0.5-i)*ineq_slope*Eps
    ret[10] = w_e - np.exp(e + eps_t + (1+f_i*ineq)*Eps_Theta)
    ret[11] = ucP - uc*P
    ret[12] = foc_pi- (- (Lambda+Nu)*psi*Pi )
    ret[13] = foc_D - ( np.exp((1-sigma)*E_Theta)*mu*uc*s_i - Nu )
    ret[14] = s_i - s_i_
    ret[15] = b - x/uc
    ret[16] = b_ - x_*m_
    ret[17] = pihat - UC*Pi*(1+Pi)*psi*np.exp(-sigma*E_Theta)
    ret[18] = Epihat_ - Epihat
    ret[19] = phillips + pihat*np.exp(sigma*E_Theta) - beta*Epihatprime -UC*Y*(1-epsilon*(1-W))
    ret[20] = i - uc/(beta*EucPprime)
    ret[21] = EucP_ - EucP
    ret[22] = omega - omega_
    
    ret[23] = mu - mu_
    ret[24] =m - m_ # bond pricing
    
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,i,b_,x_,kappa_,Epihat_,EucP_ = w[:ny] #y
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Lambda,Y,B,UC,Nu,Chi,Xi,D,S,I = w[ny+ne:ny+ne+nY] #Y
    Eps_MU_,Eps_Theta_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    epsilon = epsilonbar*np.exp(Eps_MU)
 
    m = np.exp(logm)
    uc = c**(-sigma)
    E_Theta = (1-ar)*(BarTheta + Eps)
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = rho1_- Alpha1 #alpha_1 can't depend on Eps
    ret[1] = b_ # muhat must integrate to zero for all Eps    
    
    ret[2] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[3] = phi*uc*w_e
    ret[4] = rho2   
    ret[5] = Eps_MU - rho_MU*Eps_MU_ -Eps2
    ret[6] = foc_pi
    ret[7] = Y - w_e*nl
    ret[8] = B - b
    ret[9] = foc_D
    ret[10] = UC- uc*s_i
    ret[11] = phillips
    ret[12] = Chi 
    ret[13] = Lambda + Nu*(1-W) - Xi
    ret[14] = D - ((1-W)*Y - 0.5*psi*Pi**2)
    ret[15] = S-s_i
    ret[16] = I-i
    ret[17] = Eps_Theta - rho_Theta*Eps_Theta_ - ar*Eps
    
    
    ret[18] = b_ # normalize average transfers to zero note doesn't depend on Eps here
    ret[19] = rho1_- Alpha1
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,i,b_,x_,kappa_,Epihat_,EucP_= y
    
    m = np.exp(logm)
    mu = muhat * m    
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucP
    ret[1] = ucP * mu
    ret[2] = x_
    ret[3] = rho1_
    ret[4] = pihat
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm,muhat,omega,e,s_i = z
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Lambda,Y,B,UC,Nu,Chi,Xi,D,S,V = YSS
    
    epsilon=epsilonbar
    
    m = np.exp(logm)
    mu = muhat * m
    w_e = np.exp(e)
    Uc =Alpha1/m
    c = Uc**(-1/sigma)
    Ucc =-sigma*c**(-sigma-1)  
    Un = -(1-Tau)*W*Uc*w_e
    nl = (-Un)**(1/gamma)
    Unn = -gamma*(nl**(gamma-1))
    
    
    phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
    
    rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
    
    
    x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
    
    ucP = Uc*(1+Pi)**(-1)
    rho1 = m*ucP
    
    kappa = rho1*ucP
    
    foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 

    b = x/Uc
    b_ = x*m
    
    pihat = UC*Pi*(1+Pi)*psi*np.ones(logm.shape)
    phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
    
    foc_D = ( mu*Uc*s_i - Nu )
    i = (m**0)/beta
    
    return np.vstack((
    logm,muhat,omega,e,s_i,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,i,b_,x,kappa,pihat,ucP
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,i,b_,x,kappa,pihat,EucP = y_i
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Lambda,Y,B,UC,Nu,Chi,Xi,D,S,I= YSS
    uc = c**(-sigma)
    m = np.exp(logm)
    
    
    epsilon = epsilonbar
    return np.hstack([
    Alpha1*(1+Pi)-Alpha2,                            #1
    B,                                                #2
    Eps_MU,                                           #3  
    Eps_Theta,
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),          #4 
    weights.dot(phi*uc*w_e),                         #5
    weights.dot(rho2),                               #6
    Pi,                             #7                                              #8 
    weights.dot(Y-(w_e*nl)),                          #9
    weights.dot(B-b),                                #10 
    weights.dot(foc_D),                       #12   
    weights.dot( UC- uc*s_i),                              #13
    weights.dot(phillips),                           #14  
    Chi, #15
     Lambda + Nu*(1-W)- Xi, #16
    D - ((1-W)*Y - 0.5*psi*Pi**2),                      #17  
    weights.dot(S-s_i),
    I - 1./beta
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    if weights is None:
        Gamma[:,0] -= np.mean(Gamma[:,0])
        Gamma[:,1] -= np.mean(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    else:
        Gamma[:,0] -= weights.dot(Gamma[:,0])
        Gamma[:,1] -= weights.dot(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    