# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.4])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
epsilonbar = 6.
Wbar = (epsilonbar-1)/epsilonbar
BarTheta=0.
ar = 0.
RApolicy = 0.
TauTarget = 0.

omega_vec = None
s_vec = None

k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 2 # number of measurability constraints
nG = 4 # number of aggregate measurability constraints.
ny = 32 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 10 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 25 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 5 # Number of individual states (m_{t-1},mu_{t-1})
nv = 8 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 2
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,foc_Tau_b,b,pihat,phillips,pvD,b_,PVc,PVc2,PVn,PVn2,x_,kappa_,Epihat_,EpvD_,EPVc_,EPVc2_,EPVn_,EPVn2_'.split(',')
Y_labels = 'Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Tau_b,Tau_d ,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,PVD,C,N,EPVC_,EPVN_'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,foc_Tau_b,b,pihat,phillips,pvD,b_,PVc,PVc2,PVn,PVn2,x_,kappa_,Epihat_,EpvD_,EPVc_,EPVc2_,EPVn_,EPVn2_ = w[:ny] #y
    EucP,EucPmu,Ex_,Erho1_,Epihat,EpvDhat,EPVc,EPVc2,EPVn,EPVn2 = w[ny:ny+ne] #e
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Tau_b,Tau_d ,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,PVD,C,N,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    logm_,muhat_,omega_,e_,s_i_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,kappa,Epihatprime,EpvDprime,EPVcprime,EPVc2prime,EPVnprime,EPVn2prime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_MU_,Eps_Theta_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    m_,m = np.exp(logm_),np.exp(logm)
    mu_ = muhat_ * m_
    mu = muhat * m  
    E_Theta = (1-ar)*(BarTheta + Eps)
    epsilon = epsilonbar*np.exp(Eps_MU)
    
    f_i = E(e_)
    
    uc = c**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unn = -gamma*nl**(gamma-1)
    P = np.exp(-sigma*E_Theta)*(1-Tau_b)/(1+Pi)
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0] = x_ - Ex_ # x is independent of shocks
    ret[1] = rho1_ - Erho1_   #rho1_ is independent of shocks
     
    ret[2] = x_*ucP*np.exp((sigma-1)*E_Theta)/(beta*EucP) - uc*(c-T-D*(1-Tau_d)*s_i) - un*nl - x #impl
    ret[3] = Alpha2 - m*uc #defines m
    ret[4] = (1-Tau)*W*w_e*uc + un #wage
    ret[5] = np.exp((1-sigma)*E_Theta)*omega*un - mu*np.exp((1-sigma)*E_Theta)*(unn*nl + un) + phi*unn + Xi*w_e
    ret[6] = rho2*uc + kappa - Eta
    ret[7] = (np.exp((1-sigma)*E_Theta)*omega*uc + x_*ucc*P/(beta*EucP)*(mu-mu_) - np.exp((1-sigma)*E_Theta)*mu*(ucc*(c-T-s_i*(1-Tau_d)*D) + uc)
                + rho1_*m_*ucc*P/beta +np.exp((1-sigma)*E_Theta)*rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda)
    ret[8] = kappa_ - rho1_*EucP
    ret[9] = e - rho_e*e_ - eps_p - (1-ar)*(f_i+delta)*ineq*Eps#0.5*((f_i)*Eps - f_i*(Eps**2)/0.0225)*ineq#- (0.5-i)*ineq_slope*Eps
    ret[10] = w_e - np.exp(e + eps_t + (1+ineq*f_i)*Eps_Theta)
    ret[11] = ucP - uc*P
    ret[12] = foc_pi- (  np.exp(-sigma*E_Theta)*(1+Pi)**(-2)*x_*uc*(1-Tau_b)*(mu_-mu)/(beta*EucP) - (1+Pi)**(-2)*(1-Tau_b)*np.exp((-sigma)*E_Theta)*rho1_*m_*uc/beta - (Lambda+Nu)*psi*Pi )
    ret[13] = foc_D - ( np.exp((1-sigma)*E_Theta)*mu*uc*s_i*(1-Tau_d) - Nu )
    ret[14] = s_i - s_i_
    ret[15] = b - x/uc
    ret[16] = b_ - x_*m_
    ret[17] = pihat - UC*Pi*(1+Pi)*psi*np.exp(-sigma*E_Theta)
    ret[18] = Epihat_ - Epihat
    ret[19] = phillips + pihat*np.exp(sigma*E_Theta) - beta*Epihatprime -UC*Y*(1-epsilon*(1-W))
    ret[20] = pvD - (D + beta*EpvDprime)*np.exp((1-sigma)*E_Theta)
    ret[21] = EpvD_ - EpvDhat
    ret[22] = omega - omega_
    ret[23] = foc_Tau_b -( x_*(uc/(1+Pi))*np.exp((sigma-1)*E_Theta)/(beta*EucP)*(mu_-mu) - (1+Pi)**(-1)*np.exp((-sigma)*E_Theta)*rho1_*m_*uc/beta)
    ret[24] = PVc - ((1-beta)*c + beta*EPVcprime)
    ret[25] = PVc2 - ((1-beta)*c**2 + beta*EPVc2prime)
    ret[26] = PVn - ((1-beta)*nl + beta*EPVnprime)
    ret[27] = PVn2 - ((1-beta)*nl**2 + beta*EPVn2prime)
    ret[28] = EPVc_ - EPVc
    ret[29] = EPVc2_ - EPVc2
    ret[30] = EPVn_ - EPVn
    ret[31] = EPVn2_ - EPVn2
    
    ret[32] = mu_*EucP - EucPmu
    ret[33] = Alpha1 - m_*EucP # bond pricing
    
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,foc_Tau_b,b,pihat,phillips,pvD,b_,PVc,PVc2,PVn,PVn2,x_,kappa_,Epihat_,EpvD_,EPVc_,EPVc2_,EPVn_,EPVn2_= w[:ny] #y
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Tau_b,Tau_d ,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,PVD,C,N,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    Eps_MU_,Eps_Theta_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    epsilon = epsilonbar*np.exp(Eps_MU)
 
    m = np.exp(logm)
    mu = m*muhat
    uc = c**(-sigma)
    E_Theta = (1-ar)*(BarTheta + Eps)
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = Alpha1 #alpha_1 can't depend on Eps
    ret[1] = muhat # muhat must integrate to zero for all Eps  
    ret[2] = foc_Tau_b*(1-RApolicy) + RApolicy*Tau_b
    ret[3] = muhat*s_i*(1-RApolicy) + RApolicy*Tau_d
    
    ret[4] = (1-Tau)*W - (1-TauTarget)*Wbar#phi*uc*w_e*(1-RApolicy) + RApolicy*((1-Tau)*W - (1-TauTarget)*Wbar)
    ret[5] = rho2   
    ret[6] = Eps_MU - rho_MU*Eps_MU_ -Eps2
    ret[7] = foc_pi
    ret[8] = Y - w_e*nl
    ret[9] = B - b
    ret[10] = foc_D
    ret[11] = UC- uc*s_i
    ret[12] = phillips
    ret[13] = Chi 
    ret[14] = Lambda + Nu*(1-W) - Xi
    ret[15] = D - ((1-W)*Y - 0.5*psi*Pi**2)
    ret[16] = S-s_i
    ret[17] = PVD-pvD
    ret[18] = logm #normalizing for Elogm=0
    ret[19] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[20] = Eps_Theta - rho_Theta*Eps_Theta_ - ar*Eps
    ret[21] = C - c
    ret[22] = N - nl
    ret[23] = EPVC_ - EPVc_
    ret[24] = EPVN_ - EPVn_
    
    ret[25] = Tau_b #average Tau_b =0
    ret[26] = b_ # normalize average transfers to zero note doesn't depend on Eps here
    ret[27] = rho1_
    ret[28] = Tau_d #average dividend tax targeted to zero.
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,foc_Tau_b,b,pihat,phillips,pvD,b_,PVc,PVc2,PVn,PVn2,x_,kappa_,Epihat_,EpvD_,EPVc_,EPVc2_,EPVn_,EPVn2_= y
    
    m = np.exp(logm)
    mu = muhat * m    
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucP
    ret[1] = ucP * mu
    ret[2] = x_
    ret[3] = rho1_
    ret[4] = pihat
    ret[5] = pvD
    ret[6] = PVc
    ret[7] = PVc2
    ret[8] = PVn
    ret[9] = PVn2
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm,muhat,omega,e,s_i = z
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Tau_b,Tau_d,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,PVD,C,N,PVC,PVN = YSS
    
    epsilon=epsilonbar
    
    m = np.exp(logm)
    mu = muhat * m
    w_e = np.exp(e)
    Uc =Alpha1/m
    c = Uc**(-1/sigma)
    Ucc =-sigma*c**(-sigma-1)  
    Un = -(1-Tau)*W*Uc*w_e
    nl = (-Un)**(1/gamma)
    Unn = -gamma*(nl**(gamma-1))
    
    
    phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
    
    rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D*(1-Tau_d)) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
    rho1 = -(1+Pi)*rho2
    
    x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
    
    ucP = Uc*(1+Pi)**(-1)
    
    kappa = rho1*ucP
    
    foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 

    b = x/Uc
    b_ = x*m
    
    pihat = UC*Pi*(1+Pi)*psi*np.ones(logm.shape)
    phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
    
    foc_D = ( mu*Uc*s_i - Nu )
    v = D*(m**0)/(1-beta)
    
    foc_Tau_b = - (1+Pi)**(-1)*rho1*m*Uc/beta
    
    return np.vstack((
    logm,muhat,omega,e,s_i,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_D,foc_Tau_b,b,pihat,phillips,v,b_,c,c**2,nl,nl**2,x,kappa,pihat,v,c,c**2,nl,nl**2
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_D,foc_Tau_b,b,pihat,phillips,pvD,b_,PVc,PVc2,PVn,PVn2,x,kappa,pihat,EpvD_,PVc_,PVc2_,PVn_,PVn2_ = y_i
    Eps_MU,Eps_Theta,Alpha1,Alpha2,T,Pi,W,Tau,Tau_b,Tau_d,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,PVD,C,N,PVC,PVN= YSS
    uc = c**(-sigma)
    m = np.exp(logm)
    
    
    epsilon = epsilonbar
    return np.hstack([
    Alpha1*(1+Pi)-Alpha2,                            #1
    B,                                                #2
    Eps_MU,
    Eps_Theta,                                           #3     
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),          #4 
    weights.dot(phi*uc*w_e),                         #5
    weights.dot(rho1),                               #6
    Pi,                             #7 
    Eta,                                             #8 
    weights.dot(Y-(w_e*nl)),                          #9
    weights.dot(B-b),                                #10 
    weights.dot(foc_D),                              #11  
    weights.dot( UC- uc*s_i),                              #13
    weights.dot(phillips),                           #14  
    Chi, #15
    Lambda + Nu*(1-W) - Xi, #16
    D - ((1-W)*Y - 0.5*psi*Pi**2),                      #17  
    weights.dot(S-s_i),
    weights.dot(PVD-pvD),
    Tau_b,
    Tau_d,
    weights.dot(C-c),
    weights.dot(N-nl),
    weights.dot(PVC-PVc),
    weights.dot(PVN-PVn)
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    #if (YSS[3] > 1.) | (YSS[3] < -.1):
    if (YSS[7] > 1.):    
        print ' >100 percent taxes'
        return False
    else:    
        return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    ''' 
    N = len(Gamma)
    s_i = Gamma[:,4]  
    muhat = Gamma[:,1]          
    if weights is None:
        weights = np.ones(N)/N
  
    Gamma[:,0] -= weights.dot(Gamma[:,0])
    #muhat needs to satisfy two conditions weights.dot(muhat)=0 and weights.dot(s_i*muhat=0)
    #deviations come from errors in simulation, we project down to this space
    A = np.ones((2,2))
    A[1,1] = weights.dot(s_i**2)
    lambda_1,lambda_2 = np.linalg.inv(A).dot(np.array([weights.dot(muhat),weights.dot(muhat*s_i)]))
    Gamma[:,1] -= lambda_1 + lambda_2*s_i
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    