# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.04])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
onlyineq=0.
epsilonbar = 6.
BarTheta=0.
TauTarget = 0.24
ar = 0.


omega_vec = None
s_vec = None

k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 2 # number of measurability constraints
nG = 2 # number of aggregate measurability constraints.
ny = 23 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 6 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 22 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 5 # Number of individual states (m_{t-1},mu_{t-1})
nv = 4 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 3
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logm,muhat,omega,e,s_i,c,n,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,v,b_,x_,kappa_,Epihat_,Ev_ '.split(',')
Y_labels = 'Eps_MU,Eps_Theta,Kappa,Alpha1_,Alpha2,Tr,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,V,W_e,lY'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,v,b_,x_,kappa_,Epihat_,Ev_ = w[:ny] #y
    EucP,EucPmu,Ex_,Erho1_,Epihat,Evhat = w[ny:ny+ne] #e
    Eps_MU,Eps_Theta,Kappa,Alpha1_,Alpha2,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,V,W_e,lY = w[ny+ne:ny+ne+nY] #Y
    logm_,muhat_,omega_,e_,s_i_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,kappa,Epihatprime,Evprime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_MU_,Eps_Theta_,Kappa_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps1,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps]  #aggregate shockaggregate shock
    
    m_,m = np.exp(logm_),np.exp(logm)
    mu_ = muhat_ * m_
    mu = muhat * m    
    Eps = (1. - onlyineq)*Eps1
    epsilon = epsilonbar*np.exp(Eps_MU)
    
    f_i = E(e_)
    
    uc = c**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unn = -gamma*nl**(gamma-1)
    P = 1. /(1+Pi)
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0] = x_ - Ex_ # x is independent of shocks
    ret[1] = rho1_ - Erho1_   #rho1_ is independent of shocks
 
    ret[2] = x_*ucP/(beta*EucP) - uc*(c-T-D*s_i) - un*nl - x #impl
    ret[3] = Alpha2 - m*uc #defines m
    ret[4] = (1-Tau)*W*w_e*uc + un #wage
    ret[5] = omega*un - mu*(unn*nl + un) + phi*unn + Xi*w_e
    ret[6] = rho2*uc + kappa - Eta
    ret[7] = (omega*uc + x_*ucc*P/(beta*EucP)*(mu-mu_) - mu*(ucc*(c-T-s_i*D) + uc)
                + rho1_*m_*ucc*P/beta +rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc  - Lambda)
    ret[8] = kappa_ - rho1_*EucP
    ret[9] = e - rho_e*e_ - eps_p 
    ret[10] = w_e - np.exp( e + eps_t + (1+ineq*f_i)*Eps_Theta )
    ret[11] = ucP - uc*P
    ret[12] = foc_pi- (  (1+Pi)**(-2)*x_*uc*(mu_-mu)/(beta*EucP) - (1+Pi)**(-2)*rho1_*m_*uc/beta
              -(Kappa*Alpha2*(1+2*Pi)-Kappa_*Alpha1_*(1+3*Pi)*(1+Pi))*psi- (Lambda+Nu)*psi*Pi )
    ret[13] = foc_D - ( mu*uc*s_i - Nu )
    ret[14] = s_i - s_i_
    ret[15] = b - x/uc
    ret[16] = b_ - x_*m_
    ret[17] = pihat - Alpha1_*Pi*(1+Pi)**2*psi
    ret[18] = Epihat_ - Epihat
    ret[19] = phillips + Alpha2*(psi*Pi*(1+Pi) -Y*(1-epsilon*(1-W) )) - beta*Epihatprime 
    ret[20] = v - (utility(c,nl) + beta*Evprime)
    ret[21] = Ev_ - Evhat
    ret[22] = omega-omega_
    
    ret[23] = mu_*EucP - EucPmu
    ret[24] = Alpha1_ - m_*EucP # bond pricing
    
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,v,b_,x_,kappa_,Epihat_,Ev_ = w[:ny] #y
    Eps_MU,Eps_Theta,Kappa,Alpha1_,Alpha2,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,V,W_e,lY = w[ny+ne:ny+ne+nY] #Y
    Eps_MU_,Eps_Theta_,Kappa_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps1,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps]  #aggregate shockaggregate shock
 
    m = np.exp(logm)
    uc = c**(-sigma)
    Eps = (1. - onlyineq)*Eps1
    epsilon = epsilonbar*np.exp(Eps_MU)
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = Alpha1_ #alpha_1 can't depend on Eps
    ret[1] = muhat # muhat must integrate to zero for all Eps    
    
    ret[2] = logm #normalizing for Em=1
    ret[3] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[4] = Tau-TauTarget#phi*uc*w_e
    ret[5] = -rho2   + Kappa*(psi*Pi*(1+Pi) -Y*(1-epsilon*(1-W) ))
    ret[6] = Eps_MU - rho_MU*Eps_MU_ - Eps2 
    ret[7] = foc_pi
    ret[8] = Y - w_e*nl
    ret[9] = B - b
    ret[10] = foc_D
    ret[11] = phi*uc*(1-Tau)*w_e+(epsilon)*Kappa*Alpha2*Y - Nu*Y 
    ret[12] = UC- uc*s_i
    ret[13] = phillips
    ret[14] = Kappa*Y*(1-epsilon*(1-W)) - Pi*(1+Pi)*psi*(Kappa-Kappa_) - Chi
    ret[15] = Kappa*Alpha2*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W)
    ret[16] = D - ((1-W)*Y - 0.5*psi*Pi**2)
    ret[17] = S-s_i
    ret[18] = V-v
    ret[19] = Eps_Theta - rho_Theta*Eps_Theta_ - ar*Eps
    ret[20] = W_e - w_e
    ret[21] = np.log(Y) - lY
    
    
    ret[22] = b_ # normalize average transfers to zero note doesn't depend on Eps here
    ret[23] = -rho1_ + beta*Kappa_*Epihat_/Alpha1_
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,v,b_,x_,kappa_,Epihat_,Ev_= y
    
    m = np.exp(logm)
    mu = muhat * m    
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucP
    ret[1] = ucP * mu
    ret[2] = x_
    ret[3] = rho1_
    ret[4] = pihat
    ret[5] = v
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm,muhat,omega,e,s_i = z
    Eps_MU,Eps_Theta,Kappa,Alpha1,Alpha2,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,V,W_e,lY = YSS
    
    epsilon = epsilonbar
    m = np.exp(logm)
    mu = muhat * m
    
    w_e = np.exp(e)
    Uc =Alpha1/m
    c = Uc**(-1/sigma)
    Ucc =-sigma*c**(-sigma-1)  
    Un = -(1-Tau)*W*Uc*w_e
    nl = (-Un)**(1/gamma)
    Unn = -gamma*(nl**(gamma-1))
    
    
    phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
    
    rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
    rho1 = -(1+Pi)*rho2
    
    x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
    
    ucP = Uc*(1+Pi)**(-1)
    
    kappa = rho1*ucP
    
    foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 

    b = x/Uc
    b_ = x*m
    
    pihat = Alpha1*Pi*(1+Pi)**2*psi*np.ones(logm.shape)
    phillips = -( Alpha2*Pi*(1+Pi)*psi - beta*pihat -Alpha2*Y*(1-epsilon*(1-W)))
    
    foc_D = ( mu*Uc*s_i - Nu )
    v = utility(c,nl)/(1-beta)
    
    return np.vstack((
    logm,muhat,omega,e,s_i,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,v,b_,x,kappa,pihat,v
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logm,muhat,omega,e,s_i,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_D,b,pihat,phillips,v,b_,x,kappa,pihat,Ev_ = y_i
    Eps_MU,Eps_Theta,Kappa,Alpha1,Alpha2,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,V,W_e,lY= YSS
    uc = c**(-sigma)
    m = np.exp(logm)
    epsilon = epsilonbar
    
    
    return np.hstack([
    Alpha1*(1+Pi)-Alpha2,                            #1
    B,                                                #2
    Eps_MU,
    Eps_Theta,                                           #3     
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),          #4 
    Tau-TauTarget,                         #5
    weights.dot(rho1),                               #6
    Pi,                             #7 
    Eta,                                             #8 
    weights.dot(Y-(w_e*nl)),                          #9
    weights.dot(B-b),                                #10 
    weights.dot(foc_D),                              #11
    weights.dot(phi*uc*(1-Tau)*w_e +(epsilon)*Kappa*Alpha2*Y-Nu*Y),                 #12   
    weights.dot( UC- uc*s_i),                              #13
    weights.dot(phillips),                           #14  
    Kappa*Y*(1-epsilon*(1-W)) - Chi, #15
    Kappa*Alpha2*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W), #16
    D - ((1-W)*Y - 0.5*psi*Pi**2),                      #17  
    weights.dot(S-s_i),
    weights.dot(V-v),
    weights.dot(W_e-w_e),
    lY - np.log(Y)
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    if weights is None:
        Gamma[:,0] -= np.mean(Gamma[:,0])
        Gamma[:,1] -= np.mean(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    else:
        Gamma[:,0] -= weights.dot(Gamma[:,0])
        Gamma[:,1] -= weights.dot(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    