# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.04])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
onlyineq=0.
epsilonbar = 6.
BarTheta=0.
TauTarget = 0.24
ar = 1.

RApolicy = 0.
RAKappaEps = 5.54893073e-03
RAKappaKappa = 1.09178083e-01
RAKappaEpsMU = 4.71659112e-03
RAPiEps = -6.47217184e-03
RAPiKappa = 1.03903848
RAPiEpsMU = -5.50134607e-03


omega_vec = None
s_vec = None

k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 3 # number of measurability constraints
nG = 3 # number of aggregate measurability constraints.
ny = 41 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 13 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 35 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 6 # Number of individual states (m_{t-1},mu_{t-1})
nv = 10 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 4
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logm,logmRA,muhat,omega,e,s_i,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_D,b,pihat,pihatRA,phillips,phillipsRA,v,PVc,PVc2,PVn,PVn2,b_,bRA_,x_,xRA_,kappa_,Epihat_,EpihatRA_,Ev_,EPVc_,EPVc2_,EPVn_,EPVn2_'.split(',')
Y_labels = 'Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha1,Alpha1RA,Alpha2,Alpha2RA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,UC,UCRA,Nu,Chi,Xi,D,DRA,S,V,W_e,lY,C,N,EPVC_,EPVN_'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm,logmRA,muhat,omega,e,s_i,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_D,b,pihat,pihatRA,phillips,phillipsRA,v,PVc,PVc2,PVn,PVn2,b_,bRA_,x_,xRA_,kappa_,Epihat_,EpihatRA_,Ev_,EPVc_,EPVc2_,EPVn_,EPVn2_ = w[:ny] #y
    EucP,EucPRA,EucPmu,Ex_,ExRA_,Erho1_,Epihat,EpihatRA,Evhat,EPVc,EPVc2,EPVn,EPVn2 = w[ny:ny+ne] #e
    Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha1,Alpha1RA,Alpha2,Alpha2RA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,UC,UCRA,Nu,Chi,Xi,D,DRA,S,V,W_e,lY,C,N,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    logm_,logmRA_,muhat_,omega_,e_,s_i_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,xRA,kappa,Epihatprime,EpihatRAprime,Evprime,EPVcprime,EPVc2prime,EPVnprime,EPVn2prime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_MU_,Eps_Theta_,Kappa_,RAKappa_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps1,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps]  #aggregate shockaggregate shock
    
    m_,m = np.exp(logm_),np.exp(logm)
    mRA_,mRA = np.exp(logmRA_),np.exp(logmRA)
    mu_ = muhat_ * m_
    mu = muhat * m    
    Eps = (1. - onlyineq)*Eps1
    epsilon = epsilonbar*np.exp(Eps_MU*(1-RApolicy)) #RApolicy = 1 implies no aggregate shocks for the planner
    epsilonRA = epsilonbar*np.exp(Eps_MU)
    
    f_i = E(e_)
    
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unRA= -nRA**gamma
    unn = -gamma*nl**(gamma-1)
    P = 1. /(1+Pi)
    PRA = 1. /(1+PiRA)
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0] = x_ - Ex_ # x is independent of shocks
    ret[1] = xRA_ - ExRA_
    ret[2] = rho1_ - Erho1_   #rho1_ is independent of shocks
 
    ret[3] = x_*ucP/(beta*EucP) - uc*(c-T-D*s_i) - un*nl - x #impl
    ret[4] = xRA_*ucPRA/(beta*EucPRA) - ucRA*(cRA-TRA-DRA*s_i) - unRA*nRA - xRA #impl
    ret[5] = Alpha2 - m*uc #defines m
    ret[6] = Alpha2RA - mRA*ucRA #defines m
    ret[7] = (1-Tau)*W*w_e*uc + un #wage
    ret[8] = (1-Tau)*WRA*w_eRA*ucRA + unRA #wage
    ret[9] = omega*un - mu*(unn*nl + un) + phi*unn + Xi*w_e
    ret[10] = rho2*uc + kappa - Eta
    ret[11] = (omega*uc + x_*ucc*P/(beta*EucP)*(mu-mu_) - mu*(ucc*(c-T-s_i*D) + uc)
                + rho1_*m_*ucc*P/beta + rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda)
    ret[12] = kappa_ - rho1_*EucP
    ret[13] = e - rho_e*e_ - eps_p - (1-ar)*(f_i+delta)*ineq*Eps1#0.5*((f_i)*Eps - f_i*(Eps**2)/0.0225)*ineq#- (0.5-i)*ineq_slope*Eps
    ret[14] = w_e - np.exp( e + eps_t + (1+ineq*f_i)*Eps_Theta*(1-RApolicy)  )
    ret[15] = w_eRA - np.exp( e + eps_t + (1+ineq*f_i)*Eps_Theta )
    ret[16] = ucP - uc*P
    ret[17] = ucPRA - ucRA*PRA
    ret[18] = foc_pi- (  (1+Pi)**(-2)*x_*uc*(mu_-mu)/(beta*EucP) - (1+Pi)**(-2)*rho1_*m_*uc/beta
              -(Kappa-Kappa_)*UC*(1+2*Pi)*psi- (Lambda+Nu)*psi*Pi )
    ret[19] = foc_D - ( mu*uc*s_i - Nu )
    ret[20] = s_i - s_i_
    ret[21] = b - x/uc
    ret[22] = b_ - x_*m_
    ret[23] = pihat - UC*Pi*(1+Pi)*psi
    ret[24] = pihatRA - UCRA*PiRA*(1+PiRA)*psi
    ret[25] = Epihat_ - Epihat
    ret[26] = EpihatRA_ - EpihatRA
    ret[27] = phillips + pihat - beta*Epihatprime -UC*Y*(1-epsilon*(1-W))
    ret[28] = phillipsRA + pihatRA - beta*EpihatRAprime -UCRA*YRA*(1-epsilonRA*(1-WRA))
    ret[29] = v - (utility(c,nl) + beta*Evprime)
    ret[30] = Ev_ - Evhat
    ret[31] = omega-omega_
    ret[32] = PVc - ((1-beta)*(cRA*RApolicy +(1-RApolicy)*c) + beta*EPVcprime)
    ret[33] = EPVc_ - EPVc
    ret[34] = PVc2 - ((1-beta)*(cRA*RApolicy +(1-RApolicy)*c)**2 + beta*EPVc2prime)
    ret[35] = EPVc2_ - EPVc2
    ret[36] = PVn - ((1-beta)*(nRA*RApolicy +(1-RApolicy)*nl) + beta*EPVnprime)
    ret[37] = EPVn_ - EPVn
    ret[38] = PVn2 - ((1-beta)*(nRA*RApolicy +(1-RApolicy)*nl)**2 + beta*EPVn2prime)
    ret[39] = EPVn2_ - EPVn2
    ret[40] = bRA_ - xRA_*mRA_
    
    ret[41] = mu_*EucP - EucPmu
    ret[42] = Alpha1 - m_*EucP # bond pricing
    ret[43] = Alpha1RA - mRA_*EucPRA # bond pricing
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm,logmRA,muhat,omega,e,s_i,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_D,b,pihat,pihatRA,phillips,phillipsRA,v,PVc,PVc2,PVn,PVn2,b_,bRA_,x_,xRA_,kappa_,Epihat_,EpihatRA_,Ev_,EPVc_,EPVc2_,EPVn_,EPVn2_ = w[:ny] #y
    Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha1,Alpha1RA,Alpha2,Alpha2RA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,UC,UCRA,Nu,Chi,Xi,D,DRA,S,V,W_e,lY,C,N,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    Eps_MU_,Eps_Theta_,Kappa_,RAKappa_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps1,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps]  #aggregate shockaggregate shock
 
    m = np.exp(logm)
    mRA = np.exp(logmRA)
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    Eps = (1. - onlyineq)*Eps1
    epsilon = epsilonbar*np.exp(Eps_MU*(1-RApolicy))
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = Alpha1 #alpha_1 can't depend on Eps
    ret[1] = Alpha1RA
    ret[2] = muhat # muhat must integrate to zero for all Eps    
    
    ret[3] = logm #normalizing for Em=1
    ret[4] = logmRA #normalizing for Em=1
    ret[5] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[6] = w_eRA*nRA - (psi*PiRA**2)/2 - cRA - Gov # resources
    ret[7] = Tau-TauTarget#phi*uc*w_e
    ret[8] = rho2   
    ret[9] = Eps_MU - rho_MU*Eps_MU_ - Eps2 
    ret[10] = foc_pi
    ret[11] = PiRA - Pi - RAPiKappa*RAKappa_ - RAPiEpsMU*Eps_MU_ - RAPiEps *Eps2
    ret[12] = Y - w_e*nl
    ret[13] = YRA - w_eRA*nRA
    ret[14] = B - b
    ret[15] = foc_D
    ret[16] = phi*uc*(1-Tau)*w_e+(epsilon)*Kappa*UC*Y - Nu*Y 
    ret[17] = UC- uc*s_i
    ret[18] = UCRA- ucRA*s_i
    ret[19] = phillips
    ret[20] = phillipsRA
    ret[21] = Kappa*Y*(1-epsilon*(1-W)) - Pi*(1+Pi)*psi*(Kappa-Kappa_) - Chi
    ret[22] = Kappa*UC*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W)
    ret[23] = D - ((1-W)*Y - 0.5*psi*Pi**2)
    ret[24] = DRA - ((1-WRA)*YRA - 0.5*psi*PiRA**2)
    ret[25] = S-s_i
    ret[26] = V-v
    ret[27] = Eps_Theta - rho_Theta*Eps_Theta_ - ar*Eps
    ret[28] = W_e - w_e
    ret[29] = np.log(Y) - lY
    ret[30] = C - c*(1-RApolicy) + RApolicy*cRA
    ret[31] = N - nl*(1-RApolicy) + RApolicy*nRA
    ret[32] = EPVC_ - EPVc_
    ret[33] = EPVN_ - EPVn_
    ret[34] = RAKappa - (RAKappaKappa*RAKappa_ + RAKappaEpsMU*Eps_MU_ + RAKappaEps*Eps2)

    
    ret[35] = b_ # normalize average transfers to zero note doesn't depend on Eps here
    ret[36] = bRA_
    ret[37] = rho1_
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm,logmRA,muhat,omega,e,s_i,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_D,b,pihat,pihatRA,phillips,phillipsRA,v,PVc,PVc2,PVn,PVn2,b_,bRA_,x_,xRA_,kappa_,Epihat_,EpihatRA_,Ev_,EPVc_,EPVc2_,EPVn_,EPVn2_= y
    
    m = np.exp(logm)
    mu = muhat * m    
    ret = np.empty(ne,dtype=y.dtype)
    #EucP,EucPRA,EucPmu,Ex_,ExRA_,Erho1_,Epihat,EpihatRA,Evhat,EPVc,EPVc2,EPVn,EPVn2 
    ret[0] = ucP
    ret[1] = ucPRA
    ret[2] = ucP * mu
    ret[3] = x_
    ret[4] = xRA_
    ret[5] = rho1_
    ret[6] = pihat
    ret[7] = pihatRA
    ret[8] = v
    ret[9] = PVc
    ret[10] = PVc2
    ret[11] = PVn
    ret[12] = PVn2
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm,logmRA,muhat,omega,e,s_i = z
    Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha1,Alpha1RA,Alpha2,Alpha2RA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,UC,UCRA,Nu,Chi,Xi,D,DRA,S,V,W_e,lY,C,N,EPVC_,EPVN_ = YSS
    
    epsilon = epsilonbar
    m = np.exp(logm)
    mRA = np.exp(logmRA)
    mu = muhat * m
    
    w_e = np.exp(e)
    w_eRA = np.exp(e)
    Uc =Alpha1/m
    UcRA = Alpha1RA/mRA
    c = Uc**(-1./sigma)
    cRA = UcRA**(-1./sigma)
    Ucc =-sigma*c**(-sigma-1)  
    Un = -(1-Tau)*W*Uc*w_e
    UnRA = -(1-Tau)*WRA*UcRA*w_eRA
    nl = (-Un)**(1/gamma)
    nRA = (-UnRA)**(1/gamma)
    Unn = -gamma*(nl**(gamma-1))
    
    
    phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
    
    rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
    rho1 = -(1+Pi)*rho2
    
    x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
    xRA = ( UcRA*(cRA-TRA-s_i*DRA) + UnRA*nRA )/(1./beta-1)
    
    ucP = Uc*(1+Pi)**(-1)
    ucPRA = Uc*(1+PiRA)**(-1)
    
    kappa = rho1*ucP
    
    foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 

    b = x/Uc
    b_ = x*m
    bRA_ = xRA*mRA
    
    pihat = UC*Pi*(1+Pi)*psi*np.ones(logm.shape)
    pihatRA = UCRA*PiRA*(1+PiRA)*psi*np.ones(logm.shape)
    phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
    phillipsRA = -( pihatRA - beta*pihatRA -UCRA*YRA*(1-epsilon*(1-WRA)))
    foc_D = ( mu*Uc*s_i - Nu )
    v = utility(c,nl)/(1-beta)
    PVc = c*(1-RApolicy) + cRA*RApolicy
    PVn = nl*(1-RApolicy) + nRA*RApolicy
    return np.vstack((
    logm,logmRA,muhat,omega,e,s_i,c,cRA,nl,nRA,rho1,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_D,b,pihat,pihatRA,phillips,phillipsRA,v,PVc,PVc**2,PVn,PVn**2,b_,bRA_,x,xRA,kappa,pihat,pihatRA,v,PVc,PVc**2,PVn,PVn**2
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logm,logmRA,muhat,omega,e,s_i,c,cRA,nl,nRA,rho1,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_D,b,pihat,pihatRA,phillips,phillipsRA,v,PVc,PVc2,PVn,PVn2,b_,bRA_,x_,xRA_,kappa_,Epihat_,EpihatRA_,Ev_,EPVc_,EPVc2_,EPVn_,EPVn2_ = y_i
    Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha1,Alpha1RA,Alpha2,Alpha2RA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,UC,UCRA,Nu,Chi,Xi,D,DRA,S,V,W_e,lY,C,N,EPVC_,EPVN_= YSS
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    m = np.exp(logm)
    mRA = np.exp(logmRA)
    epsilon = epsilonbar
    
    
    return np.hstack([
    Alpha1*(1+Pi)-Alpha2,                            #1
    Alpha1RA*(1+PiRA) - Alpha2RA,
    B,                                                #2
    weights.dot(bRA_),
    Eps_MU,
    Eps_Theta,                                           #3     
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),          #4 
    weights.dot(w_eRA*nRA-cRA-Gov-psi*PiRA**2 /2.),
    Tau-TauTarget,                         #5
    weights.dot(rho1),                               #6
    Pi,
    PiRA,                             #7 
    Eta,                                             #8 
    weights.dot(Y-(w_e*nl)),
    weights.dot(YRA-(w_eRA*nRA)),                          #9
    weights.dot(B-b),                                #10 
    weights.dot(foc_D),                              #11
    weights.dot(phi*uc*(1-Tau)*w_e +(epsilon)*Kappa*UC*Y-Nu*Y),                 #12   
    weights.dot( UC- uc*s_i),
    weights.dot( UCRA- ucRA*s_i),                              #13
    weights.dot(phillips),
    weights.dot(phillipsRA),                             #14  
    Kappa*Y*(1-epsilon*(1-W)) - Chi, #15
    Kappa*UC*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W), #16
    D - ((1-W)*Y - 0.5*psi*Pi**2),                      #17  
    DRA - ((1-WRA)*YRA - 0.5*psi*PiRA**2),                      #17  
    weights.dot(S-s_i),
    weights.dot(V-v),
    weights.dot(W_e-w_e),
    lY - np.log(Y),
    weights.dot(C-c*(1-RApolicy)-RApolicy*cRA),
    weights.dot(N-nl*(1-RApolicy)-RApolicy*nRA),
    weights.dot(EPVC_-PVc),
    weights.dot(EPVN_-PVn),
    RAKappa
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    #if (YSS[3] > 1.) | (YSS[3] < -.1):
    return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    if weights is None:
        Gamma[:,0] -= np.mean(Gamma[:,0])
        Gamma[:,1] -= np.mean(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
        Gamma[:,2] -= np.mean(Gamma[:,2])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])s
    else:
        Gamma[:,0] -= weights.dot(Gamma[:,0])
        Gamma[:,1] -= weights.dot(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
        Gamma[:,2] -= weights.dot(Gamma[:,2])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    