# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.4])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
Phibar = 6.
BarTheta=0.
Bbar = 0.
TauTarget = 0.24
TauD = 0.34
ar = 1.

omega_vec = None
s_vec = None

k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 2 # number of measurability constraints
nG = 1 # number of aggregate measurability constraints.
ny = 29 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 7 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 20 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 5 # Number of individual states (m_{t-1},mu_{t-1})
nv = 7 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 3
nNSZ = 1
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logmhat,muhat,omega,e,psihat,psidiff_,s_,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP_,p,s_m,a_,rho_,Eucpipi_,Eucpi_,p_,gamma_,EaFOC_'.split(',')
Y_labels = 'Eps_MU,Eps_Theta,Lambda,Psi_,Psi,Gamma_,P_,C,D,Y,W,Tr,Tau,Pi,Q,Aleph,Chi,Xi,Zeta,Kappa'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma) ## why are there two minus signs

def F(w):
    '''
    Individual first order conditions
    '''
    logmhat,muhat,omega,e,psihat,psidiff_,s_,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP_,p,s_m,a_,rho_,Eucpipi_,Eucpi_,p_,gamma_,EaFOC_ = w[:ny] #y
    EucPP,EucPPmu,Ea_,Erho_,EaFOC,Eucpipi,Eucpi = w[ny:ny+ne] #e
    Eps_MU,Eps_Theta,Lambda,Psi_,Psi,Gamma_,P_,C,D,Y,W,T,Tau,Pi,Q,Aleph,Chi,Xi,Zeta,Kappa = w[ny+ne:ny+ne+nY] #Y
    logmhat_,muhat_,omega_,e_,psihat_= w[ny+ne+nY:ny+ne+nY+nz] #z
    a,rho,Eucpipiprime,Eucpiprime,P,Gamma,EaFOCprime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_MU_,Eps_Theta_,Lambda_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    mhat_,mhat = np.exp(logmhat_),np.exp(logmhat)
    m_,m = mhat_**(sigma),mhat**(sigma)
    mu_ = muhat_ * m_
    mu = muhat * m    
    E_Theta = (1-ar)*(BarTheta + Eps)
    Phi = Phibar*np.exp(Eps_MU)
    
    f_i = E(e_)
    
    uc = c**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unn = -gamma*nl**(gamma-1)
    UC = C**(-sigma)
    
    PP = C**(sigma)*P + (1-TauD)*D + Bbar*np.exp(-E_Theta)/(1+Pi) - Bbar*Q #<B is set to Bbar>
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0]  = a_ - Ea_ # x is independent of shocks
    ret[1]  = rho_ - Erho_   #rho1_ is independent of shocks
  
    ret[2]  = a_*uc*PP/(beta*EucPP) - uc*(c-T) - un*nl - a # scaled and mu adjusted budget constraint, EucPP defined using ret[19], line 116 
    ret[3]  = uc*W*(1-Tau)*w_e +un # optimal leisure
    ret[4]  = C**(-sigma) - m*uc # definition of m_i
    ret[5]  = eta - (a_*uc/(beta*EucPP)*(mu - EucPPmu/EucPP) + m_*uc*rho_) # definition of eta_i, EucPPmu defined below as expectation of ucPP times mu
    ret[6]  = aFOC - (1./m)*np.exp(-sigma*E_Theta)*C**(-sigma)*((1+Pi)**(-1)*Psi_ + np.exp(E_Theta)*psi*Pi*(1+Pi)*Lambda_) #defines aFOC as a useful term, used later
    ret[7]  = omega*uc - sigma*PP*eta/c - (ucc*(c-T)+uc)*mu - ucc*W*(1-Tau)*w_e*phi - m**(-1/sigma)*varphi - Chi 
    ret[8]  = omega*un - (unn*nl+un)*mu - unn*phi + w_e*Kappa # FOC with respect to nl
    ret[9]  = (rho*P/m + (1/sigma)*m**(-(1+sigma)/sigma)*c*varphi - a*Gamma 
               -(a_/P_)*(m_/m)**2*m*aFOC*np.exp((sigma-1)*E_Theta)+2*beta*(a/P)*m*EaFOCprime)# <David: check this, shouldnt there be a EucPPprime multiplying the first term>
    ret[10] = ucpipi - np.exp((1-sigma)*E_Theta)*(1./m)*UC*Pi*(1+Pi) # define ucpipi for the expectational term in MUPC
    ret[11] = Eucpipi_ - Eucpipi # <David: why do we need this>
    ret[12] = phillips - (UC*Y*(1-Phi*(1-W)) - psi*UC*Pi*(1+Pi) + beta*psi*(a/P)*(m**2)*Eucpipiprime) #< MUPC >
    ret[13] = ucpi - np.exp(-sigma*E_Theta)*(1./m)*UC*(1+Pi)**(-1) # define ucpi for the expectational term in the Bond pricing equation
    ret[14] = Eucpi_ - Eucpi # <David: why do we need this>
    ret[15] = bond - (UC*Q - beta*(a/P)*(m**2)*Eucpiprime) #Euler equation of MF/Bond pricing
    ret[16] = focP_  -(-Psi_/Bbar - rho_ - beta*psi*(a_/P_**2)*(m_**2)*Eucpipi*Lambda_ - beta*(a_/P_**2)*(m_**2)*Eucpi*Psi_ + Gamma_) #foc wrt P
    ret[17] = e - rho_e*e_ - eps_p - (f_i+delta)*ineq*Eps # LOM for persistent idio skill shock 
    ret[18] = w_e - np.exp(Eps_Theta+e+eps_t) # wage 
    ret[19] = ucPP - np.exp((1-sigma)*E_Theta)*uc*PP # define ucPP for the expectational term in EE
    ret[20] = p_ - P_ #defines aGamma as a times Gamma
    ret[21] = p - P
    ret[22] = s_ - m_*a_/P_
    ret[23] = gamma_ - Gamma_
    ret[24] = (psihat - psihat_) - (Psi-Psi_)
    ret[25] = psidiff_ - (psihat_-Psi_)
    ret[26] = omega - omega_
    ret[27] = EaFOC_ - EaFOC
    ret[28] = s_m - (a_*(m_**2)/P_/m)
    
    ret[29]  = beta*m_*EucPP - P_# hh Euler equation wrt to mutual fund holding
    ret[30]  = ( EucPPmu/EucPP - mu_) - m_*Gamma_ + (beta/P_)*(m_**2)*EaFOC # foc wrt a_i
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logmhat,muhat,omega,e,psihat,psidiff_,s_,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP_,p,s_m,a_,rho_,Eucpipi_,Eucpi_,p_,gamma_,EaFOC_ = w[:ny] #y
    Eps_MU,Eps_Theta,Lambda,Psi_,Psi,Gamma_,P_,C,D,Y,W,T,Tau,Pi,Q,Aleph,Chi,Xi,Zeta,Kappa = w[ny+ne:ny+ne+nY] #Y
    Eps_MU_,Eps_Theta_,Lambda_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    Phi = Phibar*np.exp(Eps_MU)
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    uc = c**(-sigma)
    E_Theta = (1-ar)*(BarTheta + Eps)
    UC = C**(-sigma)
    UCC = -sigma*C**(-sigma-1)
    P = p
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0]  = P_ #P_ can't depend on shock 
    
    ret[1]  = C - c #Chi
    ret[2]  = Y - w_e*nl #Kappa
    ret[3]  = Y - psi*Pi**2/2 - C- Gov #Xi
    ret[4]  = D - ((1-W)*Y - psi*Pi**2/2) #Zeta
    ret[5]  = phillips  #Lambda
    ret[6]  = bond #Psi
    ret[7]  = Aleph - eta #Aleph
    ret[8]  = (varphi + sigma*C**(sigma-1)*P*Aleph + Chi - Xi - UCC*psi*Pi*(1+Pi)*(Lambda - s_m*Lambda_)
              -UCC*(Q*Psi - (1+Pi)**(-1)*s_m*np.exp(-E_Theta)*Psi_) + UCC*Y*(1-Phi*(1-W))*Lambda ) #C
    ret[9]  = focP_  #P also restricts Gamma_ independent of shocsk
    ret[10] = (1-TauD)*Aleph - Zeta  #D
    ret[11] = Xi + (1-W)*Zeta - Kappa  + UC*(1-Phi*(1-W))*Lambda #Y
    ret[12] = (-psi*Pi*(Xi+Zeta) - UC*psi*(1+2*Pi)*(Lambda - s_m*Lambda_)  #Pi  
               -UC*(1+Pi)**(-2)*s_m*np.exp(-E_Theta)*Psi_ - Bbar*np.exp(-E_Theta)*(1+Pi)**(-2)*Aleph)
    ret[13] = -Bbar*Aleph - UC*Psi #Q
    ret[14] = UC*Y*Phi*Lambda - (1-Tau)*uc*w_e*phi - Y*Zeta #W
    ret[15] = Tau - TauTarget #Tau
    ret[16] = Eps_MU - rho_MU*Eps_MU_ - Eps2 #Eps_MU
    ret[17] = muhat #T
    ret[18] = psidiff_ 
    ret[19] = Eps_Theta - Eps_Theta_*rho_Theta - ar*Eps
    
    ret[20]  = 1 - s_ #Gamma
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logmhat,muhat,omega,e,psihat,psidiff_,s_,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP_,p,s_m,a_,rho_,Eucpipi_,Eucpi_,p_,gamma_,EaFOC_ = y
    
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    mu = muhat * m  
    
    #EucPP,EucPPmu,Ea_,Erho_,EaFOC,Eucpipi,Eucpi
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucPP
    ret[1] = ucPP * mu
    ret[2] = a_
    ret[3] = rho_
    ret[4] = aFOC
    ret[5] = ucpipi
    ret[6] = ucpi
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logmhat,muhat,omega,e,psihat = z
    Eps_MU,Eps_Theta,Lambda,Psi,Psi1,Gamma,P,C,D,Y,W,T,Tau,Pi,Q,Aleph,Chi,Xi,Zeta,Kappa = YSS
    
    Phi= Phibar
    PP = C**(sigma)*P + (1-TauD)*D + Bbar/(1+Pi) - Bbar*Q
    UC = C**(-sigma)
    
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    mu = muhat * m
    
    w_e = np.exp(e)
    c = C*mhat
    uc = c**(-sigma)
    ucc =-sigma*c**(-sigma-1)  
    un = -(1-Tau)*W*uc*w_e
    nl = (-un)**(1/gamma)
    unn = -gamma*(nl**(gamma-1))
    
    a = ( uc*(c-T) + un*nl )/(1./beta-1)
    
    
    phi = (omega*un - mu*(unn*nl + un) + Kappa*w_e )/unn
    
    
    
    
    rho_dem = (-sigma*PP*m*uc/c +  m**(-1/sigma)*sigma*(P/m)/(c*m**(-(1+sigma)/sigma))) #<David: check this equation>
    rho_num = omega*uc  - (ucc*(c-T)+uc)*mu - ucc*W*(1-Tau)*w_e*phi  - Chi + m**(-1/sigma)*sigma*(1-1./beta)*a*Gamma/(c*m**(-(1+sigma)/sigma))
    
    rho = -rho_num/rho_dem #<David: check the denominator term>
    
    
    varphi = -sigma*(rho*P/m + (1-1./beta)*a*Gamma)/(c*m**(-(1+sigma)/sigma))
    
    eta =  m*uc*rho
    aFOC = (1./m)*UC*((1+Pi)**(-1)*Psi + psi*Pi*(1+Pi)*Lambda) #<David: isnt Pi=Psi=Lambda =0 >
    ucpipi = (1./m)*UC*Pi*(1+Pi)
    ucpi = (1./m)*UC*(1+Pi)**(-1)
    phillips = UC*Y*(1-Phi*(1-W)) - psi*UC*Pi*(1+Pi) + beta*psi*(a/P)*(m**2)*ucpipi
    bond = UC*Q - beta*(a/P)*(m**2)*ucpi
    focP = (C**(sigma)*Aleph - rho - beta*psi*(a/P**2)*(m**2)*ucpipi*Lambda - beta*(a/P**2)*(m**2)*ucpi*Psi+Gamma)
    ucPP = uc*PP
    s  = m*a/P
    p = P*(m**0)
    gam = Gamma*(m**0)
    psidiff = psihat-Psi
    s_m = s
    
    
    #logmhat,muhat,e,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP,ma_,a_,rho_,Eucpipi_,Eucpi_,aGamma_
    return np.vstack((
    logmhat,muhat,omega,e,psihat,psidiff,s,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP,p,s_m,a,rho,ucpipi,ucpi,p,gam,aFOC
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logmhat,muhat,omega,e,psihat,psidiff,s,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP,p,s_m,a,rho,ucpipi,ucpi,p,gam,EaFOC_ = y_i
    Eps_MU,Eps_Theta,Lambda,Psi,Psi1,Gamma,P,C,D,Y,W,T,Tau,Pi,Q,Aleph,Chi,Xi,Zeta,Kappa= YSS
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    uc = c**(-sigma)
    UCC = -sigma*C**(-sigma-1)
    UC = C**(-sigma)
    
    
    Phi= Phibar
    return np.hstack([
    weights.dot(varphi + sigma*m*uc*C**(sigma-1)*P*rho + Chi - Xi - UCC *(Q*Psi-(1+Pi)**(-1)*Psi)),
    Eps_MU,
    Eps_Theta,
    -Gamma + (beta/P)*UC*((1+Pi)**(-1)*Psi+psi*Pi*(1+Pi)*Lambda),
    weights.dot(m*uc*rho-Zeta),
    Xi+(1-W)*Zeta-Kappa,
    Pi,
    -Bbar*Aleph-UC*Psi,
    weights.dot(UC*Y*Phi*Lambda- (1-Tau)*uc*w_e*phi -Y*Zeta),
    Tau-TauTarget,
    Y-0.5*psi*Pi**2 - C- Gov,
    D - (1-W)*Y - 0.5*psi*Pi**2,
    weights.dot(Y-w_e*nl),
    W - ((Phi-1)/Phi),
    Q-beta,
    weights.dot(m*a-P),
    C**(sigma)*P - beta*((1-TauD)*D/(1-beta) + Bbar),
    weights.dot(Aleph-eta),
    Psi-Psi1,
    weights.dot(psidiff)
    ])
    

    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    #if (YSS[3] > 1.) | (YSS[3] < -.1):
    if (YSS[11] > 1.):    
        print ' >100 percent taxes'
        return False
    else:    
        return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    if weights is None:
        Gamma[:,0] -= np.log(np.mean(np.exp(Gamma[:,0])))
        Gamma[:,1] -= np.mean(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    else:
        Gamma[:,0] -= np.log(weights.dot(np.exp(Gamma[:,0])))
        Gamma[:,1] -= weights.dot(Gamma[:,1])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    