# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.4])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_NK = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
Phibar = 6.
BarTheta=0.
Bbar = 0.
TauTarget = 0.24
TauD = 0.34
ar = 1.
RApolicy = 0.
RAKappaEps = 5.54893073e-03
RAKappaKappa = 1.09178083e-01
RAKappaEpsNK = 4.71659112e-03
RAPiEps = -6.47217184e-03
RAPiKappa = 1.03903848
RAPiEpsNK = -5.50134607e-03

omega_vec = None
s_vec = None

k = 200

E = None

ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 3 # number of measurability constraints
nG = 2 # number of aggregate measurability constraints.
ny = 51 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 15 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 33 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 6 # Number of individual states (m_{t-1},mu_{t-1})
nv = 15 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 4
nNSZ = 1
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logmhat,logmhatRA,muhat,omega,e,psihat,psidiff_,s_,sRA_,c,cRA,nl,nRA,varphi,phi,ucPP,ucPPRA,w_e,w_eRA,eta,aFOC,ucpipi,ucpipiRA,ucpi,ucpiRA,phillips,phillipsRA,bond,bondRA,focP_,p,s_m,PVc,PVc2,PVn,PVn2,a_,aRA_,rho_,Eucpipi_,EucpipiRA_,Eucpi_,EucpiRA_,p_,pRA_,gamma_,EaFOC_,EPVc_,EPVc2_,EPVn_,EPVn2_'.split(',')
Y_labels = 'Eps_NK,Eps_Theta,Lambda,RAKappa,Psi_,Psi,Gamma_,P_,PRA_,C,CRA,D,DRA,Y,YRA,W,WRA,T,TRA,Tau,Pi,PiRA,Q,QRA,Aleph,Chi,Xi,Zeta,Kappa,N,NRA,EPVC_,EPVN_'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma) ## why are there two minus signs

def F(w):
    '''
    Individual first order conditions
    '''
    logmhat,logmhatRA,muhat,omega,e,psihat,psidiff_,s_,sRA_,c,cRA,nl,nRA,varphi,phi,ucPP,ucPPRA,w_e,w_eRA,eta,aFOC,ucpipi,ucpipiRA,ucpi,ucpiRA,phillips,phillipsRA,bond,bondRA,focP_,p,s_m,PVc,PVc2,PVn,PVn2,a_,aRA_,rho_,Eucpipi_,EucpipiRA_,Eucpi_,EucpiRA_,p_,pRA_,gamma_,EaFOC_,EPVc_,EPVc2_,EPVn_,EPVn2_ = w[:ny] #y
    EucPP,EucPPRA,EucPPmu,Ea_,EaRA_,Erho_,EaFOC,Eucpipi,EucpipiRA,Eucpi,EucpiRA,EPVc,EPVc2,EPVn,EPVn2 = w[ny:ny+ne] #e
    Eps_NK,Eps_Theta,Lambda,RAKappa,Psi_,Psi,Gamma_,P_,PRA_,C,CRA,D,DRA,Y,YRA,W,WRA,T,TRA,Tau,Pi,PiRA,Q,QRA,Aleph,Chi,Xi,Zeta,Kappa,N,NRA,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    logmhat_,logmhatRA_,muhat_,omega_,e_,psihat_= w[ny+ne+nY:ny+ne+nY+nz] #z
    a,aRA,rho,Eucpipiprime,EucpipiprimeRA,Eucpiprime,EucpiprimeRA,P,PRA,Gamma,EaFOCprime,EPVcprime,EPVc2prime,EPVnprime,EPVn2prime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Eps_NK_,Eps_Theta_,Lambda_,RAKappa_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    mhat_,mhat = np.exp(logmhat_),np.exp(logmhat)
    m_,m = mhat_**(sigma),mhat**(sigma)
    mRA_,mRA = np.exp(sigma*logmhatRA_),np.exp(sigma*logmhatRA)
    
    mu_ = muhat_ * m_
    mu = muhat * m    
    E_Theta = (1-ar)*(BarTheta + Eps)
    Phi = Phibar*np.exp(Eps_NK*(1-RApolicy)) #Turn off shocks when looking at RA policy to get mean policy with idiosyncratic shocks
    PhiRA = Phibar*np.exp(Eps_NK)
    
    
    
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unRA = -nRA**(gamma)
    unn = -gamma*nl**(gamma-1)
    UC = C**(-sigma)
    UCRA = CRA**(-sigma)
    
    PP = C**(sigma)*P + (1-TauD)*D + Bbar*np.exp(-E_Theta)/(1+Pi) - Bbar*Q #<B is set to Bbar>
    PPRA = CRA**(sigma)*PRA + (1-TauD)*DRA + Bbar*np.exp(-E_Theta)/(1+PiRA) - Bbar*QRA
    
    ret = np.empty(ny+n,dtype=w.dtype)
    ret[0]  = a_ - Ea_ # x is independent of shocks
    ret[1]  = aRA_ - EaRA_
    ret[2]  = rho_ - Erho_   #rho1_ is independent of shocks
  
    ret[3]  = a_*uc*PP/(beta*EucPP) - uc*(c-T) - un*nl - a # scaled and mu adjusted budget constraint, EucPP defined using ret[19], line 116 
    ret[4]  = aRA_*ucRA*PPRA/(beta*EucPPRA) - ucRA*(cRA-TRA) - unRA*nRA - aRA 
    ret[5]  = uc*W*(1-Tau)*w_e +un # optimal leisure
    ret[6]  = ucRA*WRA*(1-Tau)*w_eRA+unRA
    ret[7]  = C**(-sigma) - m*uc # definition of m_i
    ret[8]  = CRA**(-sigma) - mRA*ucRA # definition of m_i
    ret[9]  = eta - (a_*uc/(beta*EucPP)*(mu - EucPPmu/EucPP) + m_*uc*rho_) # definition of eta_i, EucPPmu defined below as expectation of ucPP times mu
    ret[10]  = aFOC - (1./m)*np.exp(-sigma*E_Theta)*C**(-sigma)*((1+Pi)**(-1)*Psi_ + np.exp(E_Theta)*psi*Pi*(1+Pi)*Lambda_) #defines aFOC as a useful term, used later
    ret[11] = omega*uc - sigma*PP*eta/c - (ucc*(c-T)+uc)*mu - ucc*W*(1-Tau)*w_e*phi - m**(-1/sigma)*varphi - Chi 
    ret[12] = omega*un - (unn*nl+un)*mu - unn*phi + w_e*Kappa # FOC with respect to nl
    ret[13] = (rho*P/m + (1/sigma)*m**(-(1+sigma)/sigma)*c*varphi - a*Gamma 
               -(a_/P_)*(m_/m)**2*m*aFOC*np.exp((sigma-1)*E_Theta)+2*beta*(a/P)*m*EaFOCprime)# <David: check this, shouldnt there be a EucPPprime multiplying the first term>
    ret[14] = ucpipi - np.exp((1-sigma)*E_Theta)*(1./m)*UC*Pi*(1+Pi) # define ucpipi for the expectational term in NKPC
    ret[15] = ucpipiRA - np.exp((1-sigma)*E_Theta)*(1./mRA)*UCRA*PiRA*(1+PiRA)
    ret[16] = Eucpipi_ - Eucpipi 
    ret[17] = EucpipiRA_ - EucpipiRA 
    ret[18] = phillips - (UC*Y*(1-Phi*(1-W)) - psi*UC*Pi*(1+Pi) + beta*psi*(a/P)*(m**2)*Eucpipiprime) #< NKPC >
    ret[19] = phillipsRA - (UCRA*YRA*(1-PhiRA*(1-WRA)) - psi*UCRA*PiRA*(1+PiRA) + beta*psi*(aRA/PRA)*(mRA**2)*EucpipiprimeRA) #< NKPC >
    ret[20] = ucpi - np.exp(-sigma*E_Theta)*(1./m)*UC*(1+Pi)**(-1) # define ucpi for the expectational term in the Bond pricing equation
    ret[21] = ucpiRA - np.exp(-sigma*E_Theta)*(1./mRA)*UCRA*(1+PiRA)**(-1) # define ucpi for the expectational term in the Bond pricing equation
    ret[22] = Eucpi_ - Eucpi
    ret[23] = EucpiRA_ - EucpiRA 
    ret[24] = bond - (UC*Q - beta*(a/P)*(m**2)*Eucpiprime) #Euler equation of MF/Bond pricing
    ret[25] = bondRA - (UCRA*QRA - beta*(aRA/PRA)*(mRA**2)*EucpiprimeRA) #Euler equation of MF/Bond pricing
    ret[26] = focP_  -(-Psi_/Bbar - rho_ - beta*psi*(a_/P_**2)*(m_**2)*Eucpipi*Lambda_ - beta*(a_/P_**2)*(m_**2)*Eucpi*Psi_ + Gamma_) #foc wrt P
    ret[27] = e - rho_e*e_ - eps_p
    ret[28] = w_e - np.exp(Eps_Theta*(1-RApolicy)+e+eps_t) # Turns off aggregate shocks when computing RA policy
    ret[29] = w_eRA - np.exp(Eps_Theta+e+eps_t) # wage 
    ret[30] = ucPP - np.exp((1-sigma)*E_Theta)*uc*PP # define ucPP for the expectational term in EE
    ret[31] = ucPPRA - np.exp((1-sigma)*E_Theta)*ucRA*PPRA # define ucPP for the expectational term in EE
    ret[32] = p_ - P_ #defines aGamma as a times Gamma
    ret[33] = pRA_ - PRA_
    ret[34] = p - P
    ret[35] = s_ - m_*a_/P_
    ret[36] = sRA_ - mRA_*aRA_/PRA_
    ret[37] = gamma_ - Gamma_
    ret[38] = (psihat - psihat_) - (Psi-Psi_)
    ret[39] = psidiff_ - (psihat_-Psi_)
    ret[40] = omega - omega_
    ret[41] = EaFOC_ - EaFOC
    ret[42] = s_m - (a_*(m_**2)/P_/m)
    ret[43] = PVc - ((1-beta)*cRA + beta*EPVcprime)
    ret[44] = PVc2 - ((1-beta)*cRA**2 + beta*EPVc2prime)
    ret[45] = PVn - ((1-beta)*nRA + beta*EPVnprime)
    ret[46] = PVn2 - ((1-beta)*nRA**2  + beta*EPVn2prime)
    ret[47] = EPVc_ - EPVc
    ret[48] = EPVc2_ - EPVc2
    ret[49] = EPVn_ - EPVn
    ret[50] = EPVn2_ - EPVn2
    
    ret[51]  = beta*m_*EucPP - P_# hh Euler equation wrt to mutual fund holding
    ret[52]  = beta*mRA_*EucPPRA - PRA_# hh Euler equation wrt to mutual fund holding
    ret[53]  = ( EucPPmu/EucPP - mu_) - m_*Gamma_ + (beta/P_)*(m_**2)*EaFOC # foc wrt a_i
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logmhat,logmhatRA,muhat,omega,e,psihat,psidiff_,s_,sRA_,c,cRA,nl,nRA,varphi,phi,ucPP,ucPPRA,w_e,w_eRA,eta,aFOC,ucpipi,ucpipiRA,ucpi,ucpiRA,phillips,phillipsRA,bond,bondRA,focP_,p,s_m,PVc,PVc2,PVn,PVn2,a_,aRA_,rho_,Eucpipi_,EucpipiRA_,Eucpi_,EucpiRA_,p_,pRA_,gamma_,EaFOC_,EPVc_,EPVc2_,EPVn_,EPVn2_ = w[:ny] #y
    Eps_NK,Eps_Theta,Lambda,RAKappa,Psi_,Psi,Gamma_,P_,PRA_,C,CRA,D,DRA,Y,YRA,W,WRA,T,TRA,Tau,Pi,PiRA,Q,QRA,Aleph,Chi,Xi,Zeta,Kappa,N,NRA,EPVC_,EPVN_= w[ny+ne:ny+ne+nY] #Y
    Eps_NK_,Eps_Theta_,Lambda_,RAKappa_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    Phi = Phibar*np.exp(Eps_NK*(1-RApolicy)) #Turn off shocks when looking at RA policy to get mean policy with idiosyncratic shocks
    PhiRA = Phibar*np.exp(Eps_NK)
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    uc = c**(-sigma)
    E_Theta = (1-ar)*(BarTheta + Eps)
    UC = C**(-sigma)
    UCC = -sigma*C**(-sigma-1)
    P = p
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0]  = P_ #P_ can't depend on shock 
    ret[1]  = PRA_ #P_ can't depend on shock
    
    ret[2]  = C - c #Chi
    ret[3]  = CRA - cRA #Chi
    ret[4]  = Y - w_e*nl #Kappa
    ret[5]  = YRA - w_eRA*nRA #Kappa
    ret[6]  = Y - psi*Pi**2/2 - C- Gov #Xi
    ret[7]  = YRA - psi*PiRA**2/2 - CRA- Gov#Xi
    ret[8]  = D - ((1-W)*Y - psi*Pi**2/2) #Zeta
    ret[9]  = DRA - ((1-WRA)*YRA - psi*PiRA**2/2) #Zeta
    ret[10] = phillips  #Lambda
    ret[11] = phillipsRA  #Lambda
    ret[12] = bond #Psi
    ret[13] = bondRA #Psi
    ret[14] = Aleph - eta #Aleph
    ret[15] = (varphi + sigma*C**(sigma-1)*P*Aleph + Chi - Xi - UCC*psi*Pi*(1+Pi)*(Lambda - s_m*Lambda_)
              -UCC*(Q*Psi - (1+Pi)**(-1)*s_m*np.exp(-E_Theta)*Psi_) + UCC*Y*(1-Phi*(1-W))*Lambda ) #C
    ret[16] = focP_  #P also restricts Gamma_ independent of shocsk
    ret[17] = (1-TauD)*Aleph - Zeta  #D
    ret[18] = Xi + (1-W)*Zeta - Kappa  + UC*(1-Phi*(1-W))*Lambda #Y
    ret[19] = (-psi*Pi*(Xi+Zeta) - UC*psi*(1+2*Pi)*(Lambda - s_m*Lambda_)  #Pi  
               -UC*(1+Pi)**(-2)*s_m*np.exp(-E_Theta)*Psi_ - Bbar*np.exp(-E_Theta)*(1+Pi)**(-2)*Aleph)
    ret[20] =  PiRA - Pi - (RAPiKappa*RAKappa_ + RAPiEpsNK*Eps_NK_ + RAPiEps *Eps2)*RApolicy
    ret[21] = -Bbar*Aleph - UC*Psi #Q
    ret[22] = UC*Y*Phi*Lambda - (1-Tau)*uc*w_e*phi - Y*Zeta #W
    ret[23] = Tau - TauTarget #Tau
    ret[24] = Eps_NK - rho_NK*Eps_NK_ - Eps2 #Eps_NK
    ret[25] = muhat #T
    ret[26] = psidiff_ 
    ret[27] = Eps_Theta - Eps_Theta_*rho_Theta - ar*Eps
    ret[28] = N - nl
    ret[29] = NRA - nRA
    ret[30] = EPVC_ - EPVc_
    ret[31] = EPVN_ - EPVn_
    ret[32] = RAKappa - (RAKappaKappa*RAKappa_ + RAKappaEpsNK*Eps_NK_ + RAKappaEps*Eps2)
    
    ret[33]  = 1 - s_ #Gamma
    ret[34]  = 1 - sRA_ #Gamma
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logmhat,logmhatRA,muhat,omega,e,psihat,psidiff_,s_,sRA_,c,cRA,nl,nRA,varphi,phi,ucPP,ucPPRA,w_e,w_eRA,eta,aFOC,ucpipi,ucpipiRA,ucpi,ucpiRA,phillips,phillipsRA,bond,bondRA,focP_,p,s_m,PVc,PVc2,PVn,PVn2,a_,aRA_,rho_,Eucpipi_,EucpipiRA_,Eucpi_,EucpiRA_,p_,pRA_,gamma_,EaFOC_,EPVc_,EPVc2_,EPVn_,EPVn2_ = y
    
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    mu = muhat * m  
    
    #EucPP,EucPPmu,Ea_,Erho_,EaFOC,Eucpipi,Eucpi
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucPP
    ret[1] = ucPPRA
    ret[2] = ucPP * mu
    ret[3] = a_
    ret[4] = aRA_
    ret[5] = rho_
    ret[6] = aFOC
    ret[7] = ucpipi
    ret[8] = ucpipiRA
    ret[9] = ucpi
    ret[10] = ucpiRA
    ret[11] = PVc
    ret[12] = PVc2
    ret[13] = PVn
    ret[14] = PVn2
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logmhat,logmhatRA,muhat,omega,e,psihat = z
    Eps_NK,Eps_Theta,Lambda,RAKappa,Psi,Psi1,Gamma,P,PRA,C,CRA,D,DRA,Y,YRA,W,WRA,T,TRA,Tau,Pi,PiRA,Q,QRA,Aleph,Chi,Xi,Zeta,Kappa,N,NRA,EPVC_,EPVN_ = YSS
    
    Phi= Phibar
    PP = C**(sigma)*P + (1-TauD)*D + Bbar/(1+Pi) - Bbar*Q
    PPRA = CRA**(sigma)*PRA + (1-TauD)*DRA + Bbar/(1+PiRA) - Bbar*QRA
    UC = C**(-sigma)
    UCRA = CRA**(-sigma)
    
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    mhatRA = np.exp(logmhatRA)
    mRA = mhatRA**sigma
    mu = muhat * m
    
    w_e = np.exp(e)
    c = C*mhat
    cRA = CRA*mhatRA
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    ucc =-sigma*c**(-sigma-1)  
    un = -(1-Tau)*W*uc*w_e
    unRA = -(1-Tau)*WRA*ucRA*w_e
    nl = (-un)**(1/gamma)
    nRA = (-unRA)**(1/gamma)
    unn = -gamma*(nl**(gamma-1))
    
    a = ( uc*(c-T) + un*nl )/(1./beta-1)
    aRA = ( ucRA*(cRA-TRA) + unRA*nRA )/(1./beta-1)
    
    
    phi = (omega*un - mu*(unn*nl + un) + Kappa*w_e )/unn
    
    
    
    
    rho_dem = (-sigma*PP*m*uc/c +  m**(-1/sigma)*sigma*(P/m)/(c*m**(-(1+sigma)/sigma))) #<David: check this equation>
    rho_num = omega*uc  - (ucc*(c-T)+uc)*mu - ucc*W*(1-Tau)*w_e*phi  - Chi + m**(-1/sigma)*sigma*(1-1./beta)*a*Gamma/(c*m**(-(1+sigma)/sigma))
    
    rho = -rho_num/rho_dem #<David: check the denominator term>
    
    
    varphi = -sigma*(rho*P/m + (1-1./beta)*a*Gamma)/(c*m**(-(1+sigma)/sigma))
    
    eta =  m*uc*rho
    aFOC = (1./m)*UC*((1+Pi)**(-1)*Psi + psi*Pi*(1+Pi)*Lambda) #<David: isnt Pi=Psi=Lambda =0 >
    ucpipi = (1./m)*UC*Pi*(1+Pi)
    ucpipiRA = (1./mRA)*UCRA*PiRA*(1+PiRA)
    ucpi = (1./m)*UC*(1+Pi)**(-1)
    ucpiRA = (1./mRA)*UCRA*(1+PiRA)**(-1)
    phillips = UC*Y*(1-Phi*(1-W)) - psi*UC*Pi*(1+Pi) + beta*psi*(a/P)*(m**2)*ucpipi
    phillipsRA = UCRA*YRA*(1-Phi*(1-WRA)) - psi*UCRA*PiRA*(1+PiRA) + beta*psi*(aRA/PRA)*(mRA**2)*ucpipiRA
    bond = UC*Q - beta*(a/P)*(m**2)*ucpi
    bondRA = UCRA*QRA - beta*(aRA/PRA)*(mRA**2)*ucpiRA
    focP = (C**(sigma)*Aleph - rho - beta*psi*(a/P**2)*(m**2)*ucpipi*Lambda - beta*(a/P**2)*(m**2)*ucpi*Psi+Gamma)
    ucPP = uc*PP
    ucPPRA = ucRA*PPRA
    s  = m*a/P
    sRA  = mRA*aRA/PRA
    p = P*(m**0)
    pRA = PRA*(m**0)
    gam = Gamma*(m**0)
    psidiff = psihat-Psi
    s_m = s
    
    
    #logmhat,muhat,e,c,nl,varphi,phi,ucPP,w_e,eta,aFOC,ucpipi,ucpi,phillips,bond,focP,ma_,a_,rho_,Eucpipi_,Eucpi_,aGamma_
    return np.vstack((
    logmhat,logmhatRA,muhat,omega,e,psihat,psidiff,s,sRA,c,cRA,nl,nRA,varphi,phi,ucPP,ucPPRA,w_e,w_e,eta,aFOC,ucpipi,ucpipiRA,ucpi,ucpiRA,phillips,phillipsRA,bond,bondRA,focP,p,s_m,c,c**2,nl,nl**2,a,aRA,rho,ucpipi,ucpipiRA,ucpi,ucpiRA,p,pRA,gam,aFOC,c,c**2,nl,nl**2
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logmhat,logmhatRA,muhat,omega,e,psihat,psidiff,s,sRA,c,cRA,nl,nRA,varphi,phi,ucPP,ucPPRA,w_e,w_eRA,eta,aFOC,ucpipi,ucpipiRA,ucpi,ucpiRA,phillips,phillipsRA,bond,bondRA,focP,p,s_m,PVc,PVc2,PVn,PVn2,a,aRA,rho,ucpipi,ucpipiRA,ucpi,ucpiRA,p,pRA,gam,EaFOC_,EPVc,EPVc2,EPVn,EPVn2 = y_i
    Eps_NK,Eps_Theta,Lambda,RAKappa,Psi,Psi1,Gamma,P,PRA,C,CRA,D,DRA,Y,YRA,W,WRA,T,TRA,Tau,Pi,PiRA,Q,QRA,Aleph,Chi,Xi,Zeta,Kappa,N,NRA,PVC,PVN= YSS
    mhat = np.exp(logmhat)
    m = mhat**(sigma)
    mhatRA = np.exp(logmhatRA)
    mRA = mhatRA**(sigma)
    uc = c**(-sigma)
    UCC = -sigma*C**(-sigma-1)
    UC = C**(-sigma)
    
    
    Phi= Phibar
    return np.hstack([
    weights.dot(varphi + sigma*m*uc*C**(sigma-1)*P*rho + Chi - Xi - UCC *(Q*Psi-(1+Pi)**(-1)*Psi)),
    Eps_NK,
    Eps_Theta,
    -Gamma + (beta/P)*UC*((1+Pi)**(-1)*Psi+psi*Pi*(1+Pi)*Lambda),
    weights.dot(m*uc*rho-Zeta),
    Xi+(1-W)*Zeta-Kappa,
    Pi,
    PiRA,
    -Bbar*Aleph-UC*Psi,
    weights.dot(UC*Y*Phi*Lambda- (1-Tau)*uc*w_e*phi -Y*Zeta),
    Tau-TauTarget,
    Y-0.5*psi*Pi**2 - C- Gov,
    YRA-0.5*psi*PiRA**2 - CRA- Gov,
    D - (1-W)*Y - 0.5*psi*Pi**2,
    DRA - (1-WRA)*YRA - 0.5*psi*PiRA**2,
    weights.dot(Y-w_e*nl),
    weights.dot(YRA-w_eRA*nRA),
    W - ((Phi-1)/Phi),
    WRA - ((Phi-1)/Phi),
    Q-beta,
    QRA-beta,
    weights.dot(m*a-P),
    weights.dot(mRA*aRA-PRA),
    C**(sigma)*P - beta*((1-TauD)*D/(1-beta) + Bbar),
    CRA**(sigma)*PRA - beta*((1-TauD)*DRA/(1-beta) + Bbar),
    weights.dot(Aleph-eta),
    Psi-Psi1,
    weights.dot(psidiff),
    weights.dot(N-nl),
    weights.dot(NRA-nRA),
    weights.dot(PVC - PVc),
    weights.dot(PVN - PVn),
    RAKappa
    ])
    

    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    return True

def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    if weights is None:
        Gamma[:,0] -= np.log(np.mean(np.exp(Gamma[:,0])))
        Gamma[:,1] -= np.log(np.mean(np.exp(Gamma[:,1])))
        Gamma[:,2] -= np.mean(Gamma[:,2])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    else:
        Gamma[:,0] -= np.log(weights.dot(np.exp(Gamma[:,0])))
        Gamma[:,1] -= np.log(weights.dot(np.exp(Gamma[:,1])))
        Gamma[:,2] -= weights.dot(Gamma[:,2])#/np.exp(Gamma[:,0]))*np.exp(Gamma[:,0])
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    