# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.04])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
epsilonbar = 6.
BarTheta=0.
htm_consumption = None
divMPC = 1.

omega_vec = None
s_vec = None
ebar_vec = None
htm_vec = None
ar = 0.

k = 200

E = None
Y_target=None
TauTarget =None
TRange = None
RApolicy = 0.
RAKappaEps = 5.54893073e-03
RAKappaKappa = 1.09178083e-01
RAKappaEpsMU = 4.71659112e-03
RAPiEps = -6.47217184e-03
RAPiKappa = 1.03903848
RAPiEpsMU = -5.50134607e-03


ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 3 # number of measurability constraints
nG = 2 # number of aggregate measurability constraints.
ny = 50 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 14 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 40 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 7 # Number of individual states (m_{t-1},mu_{t-1})
nv = 11 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 8
nNSZ = 2
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_Alpha2,foc_D,b,bRA,pihat,pihatRA,phillips,phillipsRA,dI,m,mRA,mu,b_,bRA_,foc_Pinv,foc_PinvPi,PVc,PVc2,PVn,PVn2,x_,xRA_,kappa_,Epihat_,EpihatRA_,EdI_,Efoc_PinvPi_,EPVc_,EPVc2_,EPVn_,EPVn2_'.split(',')
Y_labels = 'Pinv,PinvRA,Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha2,Alpha2RA,Alpha1_,Alpha1RA_,I_,IRA_,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,BRA,UC,UCRA,Nu,Chi,Xi,D,DRA,S,Muhat,C,CRA,N,NRA,EPVC_,EPVN_'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_Alpha2,foc_D,b,bRA,pihat,pihatRA,phillips,phillipsRA,dI,m,mRA,mu,b_,bRA_,foc_Pinv,foc_PinvPi,PVc,PVc2,PVn,PVn2,x_,xRA_,kappa_,Epihat_,EpihatRA_,EdI_,Efoc_PinvPi_,EPVc_,EPVc2_,EPVn_,EPVn2_ = w[:ny] #y
    EucP,EucPRA,EucPmu,Ex_,ExRA_,Erho1_,Epihat,EpihatRA,EdI,Efoc_PinvPi,EPVc,EPVc2,EPVn,EPVn2 = w[ny:ny+ne] #e
    Pinv,PinvRA,Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha2,Alpha2RA,Alpha1_,Alpha1RA_,I_,IRA_,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,BRA,UC,UCRA,Nu,Chi,Xi,D,DRA,S,Muhat,C,CRA,N,NRA,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    logm_or_b_,logm_or_bRA_,muhat_,omega_,e_,s_i_,htm_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,xRA,kappa,Epihatprime,EpihatprimeRA,EdIprime,Efoc_PinvPiprime,EPVcprime,EPVc2prime,EPVnprime,EPVn2prime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Pinv_,PinvRA_,Eps_MU_,Eps_Theta_,Kappa_,RAKappa_,Alpha2_,Alpha2RA_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    try:
        htm_i = ad.value(htm)
    except:
        htm_i = htm
    
    if htm_i > 0.5:
        logm = 0.
        logmRA = 0.
        logm_ = 0.
        logmRA_ = 0.
    else:
        logm = logm_or_b
        logmRA = logm_or_bRA
        logm_ = logm_or_b_
        logmRA_ = logm_or_bRA_
    
    m_= np.exp(logm_)
    mRA_ = np.exp(logmRA_)
    mu_ = muhat_ * m_
    E_Theta = (1-ar)*(BarTheta + Eps)
    
    epsilon = epsilonbar*np.exp(Eps_MU*(1-RApolicy))
    epsilonRA = epsilonbar*np.exp(Eps_MU)
    
        
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unRA = -nRA**(gamma)
    unn = -gamma*nl**(gamma-1)
    P = 1. /(1+Pi)*np.exp(-sigma*E_Theta)
    PRA = 1. /(1+PiRA)*np.exp(-sigma*E_Theta)
    
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    if htm_i > 0.5: #if hand to mouth
        ret[0] = x_ - 0.
        ret[1] = xRA_ - 0.
        ret[2] = rho1_ -0.
        
        ret[3] = c + b*Pinv - ( I_*b_*np.exp(-sigma*E_Theta)*Pinv + W*(1-Tau)*w_e*nl + T + D*s_i)
        ret[4] = cRA + b*PinvRA - ( IRA_*b_*np.exp(-sigma*E_Theta)*PinvRA + WRA*(1-Tau)*w_eRA*nRA + TRA + DRA*s_i)
    else:
        ret[0] = x_ - Ex_ # x is independent of shocks
        ret[1] = xRA_ - ExRA_ # x is independent of shocks
        ret[2] = rho1_ - Erho1_   #rho1_ is independent of shocks
     
        ret[3] = x_*ucP*np.exp((sigma-1)*E_Theta)/(beta*EucP) - uc*(c-T-D*s_i) - un*nl - x #impl
        ret[4] = xRA_*ucPRA*np.exp((sigma-1)*E_Theta)/(beta*EucPRA) - ucRA*(cRA-TRA-DRA*s_i) - unRA*nRA - xRA #impl
    ret[5] = Alpha2 - m*uc #defines m
    ret[6] = Alpha2RA - mRA*ucRA #defines m
    ret[7] = (1-Tau)*W*w_e*uc + un #wage
    ret[8] = (1-Tau)*WRA*w_eRA*ucRA + unRA #wage
    ret[9] = omega*np.exp((1-sigma)*E_Theta)*un - mu*np.exp((1-sigma)*E_Theta)*(unn*nl + un) + phi*unn + Xi*w_e
    ret[10] = rho2*uc + kappa - Eta/m
    if htm_i > 0.5:
        ret[11] = (omega*np.exp((1-sigma)*E_Theta)*uc - np.exp((1-sigma)*E_Theta)*mu*(ucc*(c-T-s_i*D + b*Pinv - I_*np.exp(-sigma*E_Theta)*b_*Pinv) + uc)
                + rho1_*m_*ucc*P/beta +np.exp((1-sigma)*E_Theta)*rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda) 
    else:
        ret[11] = (omega*np.exp((1-sigma)*E_Theta)*uc + x_*ucc*P/(beta*EucP)*(mu-mu_) - np.exp((1-sigma)*E_Theta)*mu*(ucc*(c-T-s_i*D) + uc)
                + rho1_*m_*ucc*P/beta +np.exp((1-sigma)*E_Theta)*rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda)
    ret[12] = kappa_ - rho1_*EucP
    if htm_i > 0.5: #if hand to mouth
        ret[13] = e - rho_e*e_ - eps_p
        ret[14] = w_e - np.exp(Eps_Theta*(1-RApolicy)+ e+eps_t)
        ret[15] = w_eRA - np.exp(Eps_Theta+ e+eps_t)
    else:
        ret[13] = e - rho_e*e_ - eps_p 
        ret[14] = w_e - np.exp(Eps_Theta*(1-RApolicy)+ e+eps_t)
        ret[15] = w_eRA - np.exp(Eps_Theta+ e+eps_t)
    ret[16] = ucP - uc*P
    ret[17] = ucPRA - ucRA*PRA
    if htm_i > 0.5:
        ret[18] = foc_pi- (  -Pinv*foc_PinvPi - (1+Pi)**(-2)*np.exp((-sigma)*E_Theta)*rho1_*m_*uc/beta
              -(Kappa-Kappa_)*UC*(1+2*Pi)*psi- (Lambda+Nu)*psi*Pi )
    else:
        ret[18] = foc_pi- (  np.exp(-sigma*E_Theta)*(1+Pi)**(-2)*x_*uc*(mu_-mu)/(beta*EucP) - (1+Pi)**(-2)*np.exp((-sigma)*E_Theta)*rho1_*m_*uc/beta
              -(Kappa-Kappa_)*UC*(1+2*Pi)*psi- (Lambda+Nu)*psi*Pi )
    ret[19] = foc_D - ( np.exp((1-sigma)*E_Theta)*mu*uc*s_i - Nu )
    ret[20] = s_i - s_i_
    if htm_i > 0.5:
        ret[21] = b - logm_or_b
        ret[22] = bRA - logm_or_bRA
        ret[23] = b_ - logm_or_b_
        ret[24] = bRA_ - logm_or_bRA_
    else:
        ret[21] = b - x/uc
        ret[22] = bRA - xRA/ucRA
        ret[23] = b_ - x_*m_/Alpha2_
        ret[24] = bRA_ - xRA_*mRA_/Alpha2_
    ret[25] = pihat - UC*Pi*(1+Pi)*psi*np.exp(-sigma*E_Theta)
    ret[26] = pihatRA - UCRA*PiRA*(1+PiRA)*psi*np.exp(-sigma*E_Theta)
    ret[27] = Epihat_ - Epihat
    ret[28] = EpihatRA_ - EpihatRA
    ret[29] = phillips + pihat*np.exp(sigma*E_Theta) - beta*Epihatprime -UC*Y*(1-epsilon*(1-W))
    ret[30] = phillipsRA + pihatRA*np.exp(sigma*E_Theta) - beta*EpihatprimeRA -UCRA*YRA*(1-epsilonRA*(1-WRA))
    if htm_i >0.5:
        ret[31] = dI - uc*I_*np.exp(-sigma*E_Theta)*b_*mu*Pinv
        ret[32] = EdI_ - EdI
        ret[33] = htm - htm_
        ret[34] = b - b_*np.exp(-sigma*E_Theta)
        ret[35] = bRA - bRA_*np.exp(-sigma*E_Theta)
        ret[36] = muhat - muhat_
        ret[37] = foc_Alpha2 - (-rho2 +  beta*EdIprime/Alpha2)
        ret[38] = foc_Pinv - ( np.exp(-sigma*E_Theta)*(I_-1)*uc*mu*b_ + beta*Efoc_PinvPiprime)
        ret[39] = foc_PinvPi - foc_Pinv/(1+Pi)
        ret[40] = Efoc_PinvPi_ - Efoc_PinvPi
        ret[41] = omega - omega_
    else:
        ret[31] = dI - 0.
        ret[32] = EdI_ - EdI
        ret[33] = htm - htm_
        ret[34] = mu - muhat*m
        ret[35] = m - np.exp(logm)
        ret[36] = mRA - np.exp(logmRA)
        ret[37] = foc_Alpha2 + rho2
        ret[38] = foc_Pinv
        ret[39] = foc_PinvPi
        ret[40] = Efoc_PinvPi_
        ret[41] = omega - omega_
    ret[42] = PVc - ((1-beta)*cRA + beta*EPVcprime)
    ret[43] = PVc2 - ((1-beta)*cRA**2 + beta*EPVc2prime)
    ret[44] = PVn - ((1-beta)*nRA + beta*EPVnprime)
    ret[45] = PVn2 - ((1-beta)*nRA**2 + beta*EPVn2prime)
    ret[46] = EPVc_ - EPVc
    ret[47] = EPVc2_ - EPVc2
    ret[48] = EPVn_ - EPVn
    ret[49] = EPVn2_ - EPVn2
    
        
        
    if htm_i >0.5:
        ret[50] = x_ - 0.
        ret[51] = xRA_ - 0.
        ret[52] = rho1_ - 0.
    else:
        ret[50] = mu_*EucP - EucPmu
        ret[51] = Alpha1_ - m_*EucP # bond pricing
        ret[52] = Alpha1RA_ - mRA_*EucPRA # bond pricing
    
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_Alpha2,foc_D,b,bRA,pihat,pihatRA,phillips,phillipsRA,dI,m,mRA,mu,b_,bRA_,foc_Pinv,foc_PinvPi,PVc,PVc2,PVn,PVn2,x_,xRA_,kappa_,Epihat_,EpihatRA_,EdI_,Efoc_PinvPi_,EPVc_,EPVc2_,EPVn_,EPVn2_  = w[:ny] #y
    Pinv,PinvRA,Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha2,Alpha2RA,Alpha1_,Alpha1RA_,I_,IRA_,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,BRA,UC,UCRA,Nu,Chi,Xi,D,DRA,S,Muhat,C,CRA,N,NRA,EPVC_,EPVN_ = w[ny+ne:ny+ne+nY] #Y
    Pinv_,PinvRA_,Eps_MU_,Eps_Theta_,Kappa_,RAKappa_,Alpha2_,Alpha2RA_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    try:
        htm_i = ad.value(htm)
    except:
        htm_i = htm
    
    epsilon = epsilonbar*np.exp(Eps_MU*(1-RApolicy))
    epsilonRA = epsilonbar*np.exp(Eps_MU)

    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    E_Theta = (1-ar)*(BarTheta + Eps)
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = Alpha1_ #alpha_1 can't depend on Eps
    ret[1] = Alpha1RA_ #alpha_1 can't depend on Eps
    
    ret[2] = mu*uc # muhat must integrate to zero for all Eps    
    if htm_i > 0.5:
        ret[3] = 0.*logm_or_b
        ret[4] = 0.*logm_or_bRA
    else:
        ret[3] = logm_or_b #normalizing for Em=1
        ret[4] = logm_or_bRA #normalizing for Em=1
    ret[5] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[6] = w_eRA*nRA - (psi*PiRA**2)/2 - cRA - Gov # resources
    ret[7] = Tau - TauTarget#phi*uc*w_e
    ret[8] = foc_Alpha2   
    ret[9] = Eps_MU - rho_MU*Eps_MU_ - Eps2 
    ret[10] = foc_pi
    ret[11] = PiRA - Pi - RApolicy*(RAPiKappa*RAKappa_ + RAPiEpsMU*Eps_MU_ + RAPiEps *Eps2)
    ret[12] = Y - w_e*nl
    ret[13] = YRA - w_eRA*nRA
    ret[14] = B - b
    ret[15] = BRA - bRA
    ret[16] = foc_D
    ret[17] = phi*uc*(1-Tau)*w_e+(epsilon)*Kappa*UC*Y - Nu*Y
    ret[18] = UC- uc*s_i
    ret[19] = UCRA- ucRA*s_i
    ret[20] = phillips
    ret[21] = phillipsRA
    ret[22] = Kappa*Y*(1-epsilon*(1-W)) - Pi*(1+Pi)*psi*(Kappa-Kappa_) - Chi 
    ret[23] = Kappa*UC*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W)
    ret[24] = D - ((1-W)*Y - 0.5*psi*Pi**2)
    ret[25] = DRA - ((1-WRA)*YRA - 0.5*psi*PiRA**2)
    ret[26] = S-s_i
    ret[27] = Muhat-muhat
    ret[28] = I_ - Alpha2_/(beta*Alpha1_)
    ret[29] = IRA_ - Alpha2RA_/(beta*Alpha1RA_)
    ret[30] = Pinv - Pinv_/(1+Pi)
    ret[31] = PinvRA - PinvRA_/(1+PiRA)
    ret[32] = Eps_Theta - rho_Theta*Eps_Theta_ - Eps
    ret[33] = C - c
    ret[34] = CRA - cRA
    ret[35] = N - nl
    ret[36] = NRA - nRA
    ret[37] = EPVC_ - EPVc_
    ret[38] = EPVN_ - EPVn_
    ret[39] = RAKappa - (RAKappaKappa*RAKappa_ + RAKappaEpsMU*Eps_MU_ + RAKappaEps*Eps2)
    
    ret[40] = -rho1_/beta - EdI_/Alpha1_
    if htm_i  >0.5:
        ret[41] = (b_*Pinv_ - bRA_*PinvRA_)
    else:
        ret[41] = b_ - bRA_
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm,c,cRA,nl,nRA,rho1_,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_Alpha2,foc_D,b,bRA,pihat,pihatRA,phillips,phillipsRA,dI,m,mRA,mu,b_,bRA_,foc_Pinv,foc_PinvPi,PVc,PVc2,PVn,PVn2,x_,xRA_,kappa_,Epihat_,EpihatRA_,EdI_,Efoc_PinvPi_,EPVc_,EPVc2_,EPVn_,EPVn2_ = y
    
 
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucP
    ret[1] = ucPRA
    ret[2] = ucP * mu
    ret[3] = x_
    ret[4] = xRA_
    ret[5] = rho1_
    ret[6] = pihat
    ret[7] = pihatRA
    ret[8] = dI
    ret[9] = foc_PinvPi
    ret[10] = PVc
    ret[11] = PVc2
    ret[12] = PVn
    ret[13] = PVn2
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm = z
    Pinv,PinvRA,Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha2,Alpha2RA,Alpha1_,Alpha1RA_,I,IRA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,BRA,UC,UCRA,Nu,Chi,Xi,D,DRA,S,Muhat,C,CRA,N,NRA,PVC,PVN = YSS
    
    epsilon = epsilonbar
    if np.isscalar(logm_or_b):
        

        w_e = np.exp(e)
        w_eRA = np.exp(e)
        
        
        if htm > 0.5:
            b = logm_or_b
            bRA = logm_or_bRA
            lwedge = np.log(w_e*(1-Tau)*W)
            lwedgeRA = np.log(w_eRA*(1-Tau)*WRA)
            Tincome = (I/(1+Pi)-1)*b*Pinv+T+s_i*D
            TincomeRA = (IRA/(1+PiRA)-1)*bRA*PinvRA+TRA+s_i*DRA
            c = np.exp(htm_consumption(lwedge,Tincome,grid=False))
            cRA = np.exp(htm_consumption(lwedgeRA,TincomeRA,grid=False))
            Uc = c**(-sigma)
            UcRA = cRA**(-sigma)
            m = Alpha2/Uc   
            mRA = Alpha2RA/UcRA  
        else:
            m = np.exp(logm_or_b)
            mRA = np.exp(logm_or_bRA)
            Uc =Alpha2/m
            UcRA =Alpha2RA/mRA
            c = Uc**(-1/sigma)
            cRA = UcRA**(-1/sigma)
        
        
        Ucc =-sigma*c**(-sigma-1)  
        Un = -(1-Tau)*W*Uc*w_e
        UnRA = -(1-Tau)*WRA*UcRA*w_eRA
        nl = (-Un)**(1/gamma)
        nRA = (-UnRA)**(1/gamma)
        Unn = -gamma*(nl**(gamma-1))
        
        #for HTM mu
        if htm > 0.5:
            ratio = -w_e*W*(1-Tau)*Ucc/(Unn)
            mu = (omega*Uc + ratio * omega*Un + Chi*s_i*Ucc - Lambda + Xi*w_e*ratio) / ( Ucc*(c-Tincome)+Uc + ratio*(Unn*nl+Un))
            phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
            rho2 = 0.
            rho1 = 0.
            x = 0.
            xRA = 0.
        else:
            mu = muhat * m
            phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
            rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
            rho1 = -(1+Pi)*rho2
        
            x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
            xRA = ( UcRA*(cRA-TRA-s_i*DRA) + UnRA*nRA )/(1./beta-1)
            
        ucP = Uc*(1+Pi)**(-1)
        
        ucPRA = UcRA*(1+PiRA)**(-1)
        
        kappa = rho1*ucP
        
        
        
        if htm > 0.5:
            b_ = b
            bRA_ = bRA
            dI = Uc*I*b*Pinv*mu
            foc_Pinv = Uc*mu*b/beta
            foc_pi = -Pinv*foc_Pinv/(1+Pi) - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 
        else:
            b = x/Uc
            b_ = x*m/Alpha2
            bRA = xRA/UcRA
            bRA_ = xRA*mRA/Alpha2RA
            dI = 0.
            foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 
            foc_Pinv = 0.
    
        
        
        pihat = UC*Pi*(1+Pi)*psi*np.ones(logm_or_b.shape)
        pihatRA = UCRA*PiRA*(1+PiRA)*psi*np.ones(logm_or_bRA.shape)
        phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
        phillipsRA = -( pihatRA - beta*pihatRA -UCRA*YRA*(1-epsilon*(1-WRA)))
        
        foc_D = ( mu*Uc*s_i - Nu )
        
        if htm > 0.5:
            foc_Alpha2 = (-rho2 +  beta*dI/Alpha2)
        else:
            foc_Alpha2 = -rho2
    else:
        m = np.exp(logm_or_b)
        mRA = np.exp(logm_or_bRA)
        mu = muhat * m
        w_e = np.exp(e)
        w_eRA = np.exp(e)
        Uc =Alpha2/m
        UcRA =Alpha2RA/mRA
        c = Uc**(-1/sigma)
        cRA = UcRA**(-1/sigma)
        
        b = np.copy(logm_or_b)
        b_ = np.copy(b)
        bRA = np.copy(logm_or_bRA)
        bRA_ = np.copy(bRA)
        lwedge =np.log( w_e[htm>0.5]*(1-Tau)*W )
        lwedgeRA =np.log( w_eRA[htm>0.5]*(1-Tau)*WRA )
        Tvec = T+s_i[htm>0.5]*D + (I-1)*b[htm>0.5]*Pinv
        TvecRA = TRA+s_i[htm>0.5]*DRA + (IRA-1)*bRA[htm>0.5]*PinvRA
        c[htm>0.5] = np.exp(htm_consumption(lwedge,Tvec,grid=False))
        cRA[htm>0.5] = np.exp(htm_consumption(lwedgeRA,TvecRA,grid=False))
        Uc[htm>0.5] = c[htm>0.5]**(-sigma)
        UcRA[htm>0.5] = cRA[htm>0.5]**(-sigma)
        m[htm>0.5] = Alpha2/Uc[htm>0.5]    
        mRA[htm>0.5] = Alpha2RA/UcRA[htm>0.5] 
        
        Ucc =-sigma*c**(-sigma-1)  
        Un = -(1-Tau)*W*Uc*w_e 
        UnRA = -(1-Tau)*WRA*UcRA*w_eRA
        nl = (-Un)**(1/gamma)
        nRA = (-UnRA)**(1/gamma)
        Unn = -gamma*(nl**(gamma-1))
        
        #for HTM mu
        ratio = -w_e[htm>0.5]*W*(1-Tau)*Ucc[htm>0.5]/(Unn[htm>0.5])
        mu[htm>0.5] = (omega[htm>0.5]*Uc[htm>0.5] + ratio *omega[htm>0.5]* Un[htm>0.5] + Chi*s_i[htm>0.5]*Ucc[htm>0.5]-Lambda + Xi*w_e[htm>0.5]*ratio) / ( Ucc[htm>0.5]*(c[htm>0.5]-Tvec)+Uc[htm>0.5] + ratio*(Unn[htm>0.5]*nl[htm>0.5]+Un[htm>0.5]))
        
        phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
        
        rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
        rho1 = -(1+Pi)*rho2
        rho2[htm>0.5] = 0.
        rho1[htm>0.5] = 0.
        
        x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
        xRA = ( UcRA*(cRA-TRA-s_i*DRA) + UnRA*nRA )/(1./beta-1)
        x[htm>0.5] = 0.
        xRA[htm>0.5] = 0.
        b[htm<=0.5] = x[htm<=0.5]/Uc[htm<=0.5]
        bRA[htm<=0.5] = xRA[htm<=0.5]/UcRA[htm<=0.5]
        b_[htm<=0.5] = x[htm<=0.5]*m[htm<=0.5]/Alpha2
        bRA_[htm<=0.5] = xRA[htm<=0.5]*mRA[htm<=0.5]/Alpha2RA
        
        ucP = Uc*(1+Pi)**(-1)
        ucPRA = UcRA*(1+PiRA)**(-1)
        
        kappa = rho1*ucP
        
        dI = Uc*I*mu*b*Pinv
        dI[htm<=0.5] = 0.
        foc_Pinv = Uc*mu*b/beta
        foc_Pinv[htm<=0.5] = 0.
        foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 
        foc_pi[htm>0.5] += -Pinv*foc_Pinv[htm>0.5]/(1+Pi)
        
    
        
        
        pihat = UC*Pi*(1+Pi)*psi*np.ones(logm_or_b.shape)
        pihatRA = UCRA*PiRA*(1+PiRA)*psi*np.ones(logm_or_bRA.shape)
        phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
        phillipsRA = -( pihatRA - beta*pihatRA -UCRA*YRA*(1-epsilon*(1-WRA)))
        
        foc_D = ( mu*Uc*s_i - Nu )
        foc_Alpha2 = -rho2
        foc_Alpha2[htm>0.5] += beta*dI[htm>0.5]/Alpha2
        
    #logm_or_b,muhat,e,s_i,htm,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,x_,kappa_,Epihat_,EdI_
    return np.vstack((
    logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm,c,cRA,nl,nRA,rho1,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_Alpha2,foc_D,b,bRA,pihat,pihatRA,phillips,phillipsRA,dI,m,mRA,mu,b_,bRA_,foc_Pinv,foc_Pinv,c,c**2,nl,nl**2,x,xRA,kappa,pihat,pihatRA,dI,foc_Pinv,c,c**2,nl,nl**2
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    logm_or_b,logm_or_bRA,muhat,omega,e,s_i,htm,c,cRA,nl,nRA,rho1,rho2,phi,ucP,ucPRA,w_e,w_eRA,foc_pi,foc_Alpha2,foc_D,b,bRA,pihat,pihatRA,phillips,phillipsRA,dI,m,mRA,mu,b_,bRA_,foc_Pinv,foc_PinvPi,PVc,PVc2,PVn,PVn2,x,xRA,kappa,pihat,pihatRA,EdI_,foc_PinvPi_,PVc_,PVc2_,PVn_,PVn2_ = y_i
    Pinv,PinvRA,Eps_MU,Eps_Theta,Kappa,RAKappa,Alpha2,Alpha2RA,Alpha1_,Alpha1RA_,I,IRA,T,TRA,Pi,PiRA,W,WRA,Tau,Lambda,Eta,Y,YRA,B,BRA,UC,UCRA,Nu,Chi,Xi,D,DRA,S,Muhat,C,CRA,N,NRA,PVC,PVN= YSS
    uc = c**(-sigma)
    ucRA = cRA**(-sigma)
    
    epsilon = epsilonbar
    htm_i = htm >= 0.5
    
    return np.hstack([
    Alpha1_*(1+Pi)-Alpha2,                            #1
    Alpha1RA_*(1+PiRA)-Alpha2RA,
    weights.dot(mu*uc),                                                #2
    T-TRA,#weights.dot(b_*(Pinv*htm_i+(1-htm_i)) - bRA_*(PinvRA*htm_i+(1-htm_i))),
    Eps_MU,                                          #3     
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),          #4 
    weights.dot(w_eRA*nRA-cRA-Gov-psi*PiRA**2 /2.), 
    Tau-TauTarget,                         #5
    weights.dot(-rho1/beta - EdI_/Alpha1_),                               #6
    Pi,                             #7 
    PiRA,
    Eta,                                             #8 
    weights.dot(Y-(w_e*nl)),                          #9
    weights.dot(YRA-(w_eRA*nRA)),
    weights.dot(B-b),                                #10 
    weights.dot(BRA-bRA),
    weights.dot(foc_D),                              #11
    weights.dot(phi*uc*(1-Tau)*w_e +(epsilon)*Kappa*UC*Y-Nu*Y),                 #12   
    weights.dot( UC- uc*s_i),                              #13
    weights.dot( UCRA- ucRA*s_i),
    weights.dot(phillips),                           #14 
    weights.dot(phillipsRA), 
    Kappa*Y*(1-epsilon*(1-W)) - Chi, #15
    Kappa*UC*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W), #16
    D - ((1-W)*Y - 0.5*psi*Pi**2),                      #17  
    DRA - ((1-WRA)*YRA - 0.5*psi*PiRA**2), 
    weights.dot(S-s_i),
    weights.dot(Muhat-muhat),
    I - Alpha2/(beta*Alpha1_),
    IRA - Alpha2RA/(beta*Alpha1RA_),
    Eps_Theta,
    weights.dot(C-c),
    weights.dot(CRA-cRA),
    weights.dot(N-nl),
    weights.dot(NRA-nRA),
    weights.dot(PVC-PVc),
    weights.dot(PVN-PVn),
    RAKappa
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    htm = Gamma[:,5]
    nothtm = htm < .5
    if weights is None:
        weights = np.ones(len(Gamma))/len(Gamma)
    Gamma[nothtm,0] -= weights[nothtm].dot(Gamma[nothtm,0])/weights[nothtm].sum()#np.log(weights[nothtm].dot(np.exp(Gamma[nothtm,0]))/weights[nothtm].sum())
    Gamma[nothtm,1] -= weights[nothtm].dot(Gamma[nothtm,1])/weights[nothtm].sum()
    #if Y_target is not None:
    #Gamma[nothtm,1] += (Y_target[-1] - weights.dot(Gamma[:,1]))/weights[nothtm].sum()
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    