# -*- coding: utf-8 -*-
"""
Created on Thu Apr 17 12:18:27 2014

@author: dgevans
"""
import numpy as np
import pycppad as ad

sigma =2.
gamma = 2.
psi = 1.
beta = 0.98
sigma_e = np.array([0.0,0.])
sigma_E = np.diag([0.03,0.04])
chi = 0.72
ineq_slope= 1.05
tfp_level=1.
Gov = 0.096
rho_MU = 0.55
rho_Theta = 0.8
delta = 0.
ineq = 1.
epsilonbar = 6.
BarTheta=0.
htm_consumption = None
divMPC = 0.
Dbar = None

omega_vec = None
s_vec = None
ebar_vec = None
htm_vec = None
ar = 0.

k = 200

E = None
Y_target=None
TauTarget =None
TRange = None


ll = np.array([-np.inf,-np.inf,-np.inf])
ul = np.array([np.inf,np.inf,np.inf])
bgp_flag=0
n = 2 # number of measurability constraints
nG = 1 # number of aggregate measurability constraints.
ny = 32 # number of individual controls (m_{t},mu_{t},c_{t},l_{t},rho1_,rho2,phi,x_{t-1},kappa_{t-1}) Note that the forward looking terms are at the end
ne = 8 # number of Expectation Terms (E_t u_{c,t+1}, E_t u_{c,t+1}mu_{t+1} E_{t}x_{t-1 E_t rho_{1,t-1}} [This makes the control x_{t-1},rho_{t-1} indeed time t-1 measuable])
nY = 23 # Number of aggregates (alpha_1,alpha_2,tau,eta,lambda)
nz = 6 # Number of individual states (m_{t-1},mu_{t-1})
nv = 6 # number of forward looking terms (x_t,rho1_t)
n_p = 1 #number of parameters
nZ = 6
nNSZ = 2
neps = len(sigma_e)
nEps = 2


phat = np.array([-0.00])

y_labels = 'logm_or_b,muhat,omega,e,s_i,htm,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,foc_Pinv,foc_PinvPi,foc_BD,x_,kappa_,Epihat_,EdI_,Efoc_PinvPi_,Efoc_BD_'.split(',')
Y_labels = 'Pinv,BD,Eps_MU,Eps_Theta,Kappa,Alpha2,Alpha1_,I_,Tr,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,Muhat'.split(',')

def utility(c,nl):
    if sigma == 1:
        return np.log(c) -nl**(1+gamma)/(1+gamma)
    else:
        return (c**(1-sigma)-1)/(1-sigma) - -nl**(1+gamma)/(1+gamma)

def F(w):
    '''
    Individual first order conditions
    '''
    logm_or_b,muhat,omega,e,s_i,htm,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,foc_Pinv,foc_PinvPi,foc_BD,x_,kappa_,Epihat_,EdI_,Efoc_PinvPi_,Efoc_BD_ = w[:ny] #y
    EucP,EucPmu,Ex_,Erho1_,Epihat,EdI,Efoc_PinvPi,Efoc_BD = w[ny:ny+ne] #e
    Pinv,BD,Eps_MU,Eps_Theta,Kappa,Alpha2,Alpha1_,I_,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,Muhat = w[ny+ne:ny+ne+nY] #Y
    logm_or_b_,muhat_,omega_,e_,s_i_,htm_= w[ny+ne+nY:ny+ne+nY+nz] #z
    x,kappa,Epihatprime,EdIprime,Efoc_PinvPiprime,Efoc_BDprime = w[ny+ne+nY+nz:ny+ne+nY+nz+nv] #v
    rho_e = w[ny+ne+nY+nz+nv+n_p-1] #p
    Pinv_,BD_,Eps_MU_,Eps_Theta_,Kappa_,Alpha2_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    try:
        htm_i = ad.value(htm)
    except:
        htm_i = htm
    
    if htm_i > 0.5:
        logm = 0.
        logm_ = 0.
    else:
        logm = logm_or_b
        logm_ = logm_or_b_
    
    m_= np.exp(logm_)
    mu_ = muhat_ * m_
    E_Theta = (1-ar)*(BarTheta + Eps)
    
    epsilon = epsilonbar*np.exp(Eps_MU)
    
        
    f_i = E(e_)
    uc = c**(-sigma)
    ucc = -sigma*c**(-sigma-1)
    un = -nl**(gamma)
    unn = -gamma*nl**(gamma-1)
    P = 1. /(1+Pi)*np.exp(-sigma*E_Theta)
    
    
    
    ret = np.empty(ny+n,dtype=w.dtype)
    if htm_i > 0.5: #if hand to mouth
        ret[0] = x_ - 0.
        ret[1] = rho1_ -0.
        
        ret[2] = c + (b+s_i*BD)*Pinv - ( I_*(b_+s_i*BD_)*np.exp(-sigma*E_Theta)*Pinv + W*(1-Tau)*w_e*nl + T + D*s_i)
    else:
        ret[0] = x_ - Ex_ # x is independent of shocks
        ret[1] = rho1_ - Erho1_   #rho1_ is independent of shocks
     
        ret[2] = x_*ucP*np.exp((sigma-1)*E_Theta)/(beta*EucP) - uc*(c-T-D*s_i) - un*nl - x #impl
    ret[3] = Alpha2 - m*uc #defines m
    ret[4] = (1-Tau)*W*w_e*uc + un #wage
    ret[5] = omega*np.exp((1-sigma)*E_Theta)*un - mu*np.exp((1-sigma)*E_Theta)*(unn*nl + un) + phi*unn + Xi*w_e
    ret[6] = rho2*uc + kappa - Eta
    if htm_i > 0.5:
        ret[7] = (omega*np.exp((1-sigma)*E_Theta)*uc - np.exp((1-sigma)*E_Theta)*mu*(ucc*(c-T-s_i*D + (b+s_i*BD)*Pinv - I_*np.exp(-sigma*E_Theta)*(b_+s_i*BD_)*Pinv) + uc)
                + rho1_*m_*ucc*P/beta +np.exp((1-sigma)*E_Theta)*rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda) 
    else:
        ret[7] = (omega*np.exp((1-sigma)*E_Theta)*uc + x_*ucc*P/(beta*EucP)*(mu-mu_) - np.exp((1-sigma)*E_Theta)*mu*(ucc*(c-T-s_i*D) + uc)
                + rho1_*m_*ucc*P/beta +np.exp((1-sigma)*E_Theta)*rho2*m*ucc + phi*w_e*W*(1-Tau)*ucc + Chi*s_i*ucc - Lambda)
    ret[8] = kappa_ - rho1_*EucP
    if htm_i > 0.5: #if hand to mouth
        ret[9] = e - rho_e*e_ - eps_p - (f_i+delta)*ineq*Eps
        ret[10] = w_e - np.exp(Eps_Theta+ e+eps_t)
    else:
        ret[9] = e - rho_e*e_ - eps_p - (f_i+delta)*ineq*Eps#0.5*((f_i)*Eps - f_i*(Eps**2)/0.0225)*ineq#- (0.5-i)*ineq_slope*Eps
        ret[10] = w_e - np.exp(Eps_Theta+ e+eps_t)
    ret[11] = ucP - uc*P
    if htm_i > 0.5:
        ret[12] = foc_pi- (  -Pinv*foc_PinvPi - (1+Pi)**(-2)*np.exp((-sigma)*E_Theta)*rho1_*m_*uc/beta
              -(Kappa-Kappa_)*UC*(1+2*Pi)*psi- (Lambda+Nu)*psi*Pi )
        ret[13] = foc_D - ( np.exp((1-sigma)*E_Theta)*mu*uc*s_i + (1-divMPC)*(-mu*uc*s_i+beta*Efoc_BDprime) - Nu )
    else:
        ret[12] = foc_pi- (  np.exp(-sigma*E_Theta)*(1+Pi)**(-2)*x_*uc*(mu_-mu)/(beta*EucP) - (1+Pi)**(-2)*np.exp((-sigma)*E_Theta)*rho1_*m_*uc/beta
              -(Kappa-Kappa_)*UC*(1+2*Pi)*psi- (Lambda+Nu)*psi*Pi )
        ret[13] = foc_D - ( np.exp((1-sigma)*E_Theta)*mu*uc*s_i - Nu )
    ret[14] = s_i - s_i_
    if htm_i > 0.5:
        ret[15] = b - logm_or_b
        ret[16] = b_ - logm_or_b_
    else:
        ret[15] = b - x/uc
        ret[16] = b_ - x_*m_
    ret[17] = pihat - UC*Pi*(1+Pi)*psi*np.exp(-sigma*E_Theta)
    ret[18] = Epihat_ - Epihat
    ret[19] = phillips + pihat*np.exp(sigma*E_Theta) - beta*Epihatprime -UC*Y*(1-epsilon*(1-W))
    if htm_i >0.5:
        ret[20] = dI - uc*I_*np.exp(-sigma*E_Theta)*(b_+s_i*BD_)*mu*Pinv
        ret[21] = EdI_ - EdI
        ret[22] = htm - htm_
        ret[23] = b - b_*np.exp(-sigma*E_Theta)
        ret[24] = muhat - muhat_
        ret[25] = foc_Alpha2 - (-rho2 +  beta*EdIprime/Alpha2)
        ret[26] = foc_Pinv - ( np.exp(-sigma*E_Theta)*(I_-1)*uc*mu*(b_+s_i*BD_) + beta*Efoc_PinvPiprime)
        ret[27] = foc_PinvPi - foc_Pinv/(1+Pi)
        ret[28] = Efoc_PinvPi_ - Efoc_PinvPi
        ret[29] = foc_BD - (uc*mu*(I_-1)*s_i*Pinv + beta*Efoc_BDprime)
        ret[30] = Efoc_BD_ - Efoc_BD
        ret[31] = omega - omega_
        
        ret[32] = x_ - 0.
        ret[33] = rho1_ - 0.
    else:
        ret[20] = dI - 0.
        ret[21] = EdI_ - EdI
        ret[22] = htm - htm_
        ret[23] = mu - muhat*m
        ret[24] = m - np.exp(logm)
        ret[25] = foc_Alpha2 + rho2
        ret[26] = foc_Pinv
        ret[27] = foc_PinvPi
        ret[28] = Efoc_PinvPi_
        ret[29] = foc_BD
        ret[30] = Efoc_BD_
        ret[31] = omega - omega_
        
        ret[32] = mu_*EucP - EucPmu
        ret[33] = Alpha1_ - m_*EucP # bond pricing
    
    return ret
    
def G(w):
    '''
    Aggregate equations
    '''
    logm_or_b,muhat,omega,e,s_i,htm,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,foc_Pinv,foc_PinvPi,foc_BD,x_,kappa_,Epihat_,EdI_,Efoc_PinvPi_,Efoc_BD_ = w[:ny] #y
    Pinv,BD,Eps_MU,Eps_Theta,Kappa,Alpha2,Alpha1_,I_,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,Muhat = w[ny+ne:ny+ne+nY] #Y
    Pinv_,BD_,Eps_MU_,Eps_Theta_,Kappa_,Alpha2_ = w[ny+ne+nY+nz+nv+n_p:ny+ne+nY+nz+nv+n_p+nZ] #Z
    eps_p,eps_t = w[ny+ne+nY+nz+nv+n_p+nZ:ny+ne+nY+nz+nv+n_p+nZ+neps] #shock
    Eps,Eps2 = w[ny+ne+nY+nz+nv+n_p+nZ+neps:ny+ne+nY+nz+nv+n_p+nZ+neps+nEps] #aggregate shockaggregate shock
    
    try:
        htm_i = ad.value(htm)
    except:
        htm_i = htm
    
    epsilon = epsilonbar*np.exp(Eps_MU)

    uc = c**(-sigma)
    E_Theta = (1-ar)*(BarTheta + Eps)
    
    ret = np.empty(nY+nG,dtype=w.dtype)
    ret[0] = Alpha1_ #alpha_1 can't depend on Eps
    
    ret[1] = mu*uc # muhat must integrate to zero for all Eps    
    if htm_i > 0.5:
        ret[2] = 0.*logm_or_b
    else:
        ret[2] = logm_or_b #normalizing for Em=1
    ret[3] = w_e*nl - (psi*Pi**2)/2 - c - Gov # resources
    ret[4] = Tau - TauTarget#phi*uc*w_e
    ret[5] = foc_Alpha2   
    ret[6] = Eps_MU - rho_MU*Eps_MU_ - Eps2 
    ret[7] = foc_pi
    ret[8] = Y - w_e*nl
    ret[9] = B - b
    ret[10] = foc_D
    ret[11] = phi*uc*(1-Tau)*w_e+(epsilon)*Kappa*UC*Y - Nu*Y
    ret[12] = UC- uc*s_i
    ret[13] = phillips
    ret[14] = Kappa*Y*(1-epsilon*(1-W)) - Pi*(1+Pi)*psi*(Kappa-Kappa_) - Chi 
    ret[15] = Kappa*UC*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W)
    ret[16] = D - ((1-W)*Y - 0.5*psi*Pi**2)
    ret[17] = S-s_i
    ret[18] = Muhat-muhat
    ret[19] = I_ - Alpha2_/(beta*Alpha1_)
    ret[20] = Pinv - Pinv_/(1+Pi)
    ret[21] = BD - (BD_ + (1-divMPC)*(D-Dbar)/Pinv)
    ret[22] = Eps_Theta - rho_Theta*Eps_Theta_ - Eps
    
    ret[23] = -rho1_/beta - EdI_/Alpha1_
    
    return ret
    
def f(y):
    '''
    Expectational equations that define e=Ef(y)
    '''
    logm_or_b,muhat,omega,e,s_i,htm,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,foc_Pinv,foc_PinvPi,foc_BD,x_,kappa_,Epihat_,EdI_,Efoc_PinvPi_,Efoc_BD_= y
    
 
    ret = np.empty(ne,dtype=y.dtype)
    ret[0] = ucP
    ret[1] = ucP * mu
    ret[2] = x_
    ret[3] = rho1_
    ret[4] = pihat
    ret[5] = dI
    ret[6] = foc_PinvPi
    ret[7] = foc_BD
    
    return ret
    
def Finv(YSS,z):
    '''
    Given steady state YSS solves for y_i
    '''
    logm_or_b,muhat,omega,e,s_i,htm = z
    Pinv,BD,Eps_MU,Eps_Theta,Kappa,Alpha2,Alpha1_,I,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,Muhat = YSS
    
    epsilon = epsilonbar
    if np.isscalar(logm_or_b):
        

        w_e = np.exp(e)
        
        
        if htm > 0.5:
            b = logm_or_b
            lwedge = np.log(w_e*(1-Tau)*W)
            Tincome = (I/(1+Pi)-1)*(b+s_i*BD)*Pinv+T+s_i*D
            c = np.exp(htm_consumption(lwedge,Tincome,grid=False))
            Uc = c**(-sigma)
            m = Alpha2/Uc    
        else:
            m = np.exp(logm_or_b)
            Uc =Alpha2/m
            c = Uc**(-1/sigma)
        
        
        Ucc =-sigma*c**(-sigma-1)  
        Un = -(1-Tau)*W*Uc*w_e
        nl = (-Un)**(1/gamma)
        Unn = -gamma*(nl**(gamma-1))
        
        #for HTM mu
        if htm > 0.5:
            ratio = -w_e*W*(1-Tau)*Ucc/(Unn)
            mu = (omega*Uc + ratio * omega*Un + Chi*s_i*Ucc - Lambda + Xi*w_e*ratio) / ( Ucc*(c-Tincome)+Uc + ratio*(Unn*nl+Un))
            phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
            rho2 = 0.
            rho1 = 0.
            x = 0.
        else:
            mu = muhat * m
            phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
            rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
            rho1 = -(1+Pi)*rho2
        
            x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
        
        ucP = Uc*(1+Pi)**(-1)
        
        kappa = rho1*ucP
        
        
        
        if htm > 0.5:
            b_ = b
            dI = Uc*I*(b+s_i*BD)*Pinv*mu
            foc_Pinv = Uc*mu*(b+s_i*BD)/beta
            foc_pi = -Pinv*foc_Pinv/(1+Pi) - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 
            foc_BD = mu*Uc*s_i*Pinv/beta
        else:
            b = x/Uc
            b_ = x*m
            dI = 0.
            foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 
            foc_Pinv = 0.
            foc_BD = 0.
    
        
        
        pihat = UC*Pi*(1+Pi)*psi*np.ones(logm_or_b.shape)
        phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
        
        foc_D = ( mu*Uc*s_i - Nu )
        
        
        if htm > 0.5:
            foc_Alpha2 = (-rho2 +  beta*dI/Alpha2)
        else:
            foc_Alpha2 = -rho2
    else:
        m = np.exp(logm_or_b)
        mu = muhat * m
        w_e = np.exp(e)
        Uc =Alpha2/m
        c = Uc**(-1/sigma)
        
        b = np.copy(logm_or_b)
        b_ = np.copy(b)
        lwedge =np.log( w_e[htm>0.5]*(1-Tau)*W )
        Tvec = T+s_i[htm>0.5]*D + (I-1)*(b[htm>0.5]+s_i[htm>0.5]*BD)*Pinv
        c[htm>0.5] = np.exp(htm_consumption(lwedge,Tvec,grid=False))
        Uc[htm>0.5] = c[htm>0.5]**(-sigma)
        m[htm>0.5] = Alpha2/Uc[htm>0.5]    
        
        Ucc =-sigma*c**(-sigma-1)  
        Un = -(1-Tau)*W*Uc*w_e
        nl = (-Un)**(1/gamma)
        Unn = -gamma*(nl**(gamma-1))
        
        #for HTM mu
        ratio = -w_e[htm>0.5]*W*(1-Tau)*Ucc[htm>0.5]/(Unn[htm>0.5])
        mu[htm>0.5] = (omega[htm>0.5]*Uc[htm>0.5] + ratio *omega[htm>0.5]* Un[htm>0.5] + Chi*s_i[htm>0.5]*Ucc[htm>0.5]-Lambda + Xi*w_e[htm>0.5]*ratio) / ( Ucc[htm>0.5]*(c[htm>0.5]-Tvec)+Uc[htm>0.5] + ratio*(Unn[htm>0.5]*nl[htm>0.5]+Un[htm>0.5]))
        
        phi = (omega*Un - mu*(Unn*nl + Un) + Xi*w_e )/(-Unn)
        
        rho2 = (omega*Uc - mu*(Ucc*(c-T-s_i*D) + Uc) + phi*w_e*Ucc*(1-Tau)*W +Chi*s_i*Ucc-Lambda)/ (m*Ucc*(1./beta-1))
        rho1 = -(1+Pi)*rho2
        rho2[htm>0.5] = 0.
        rho1[htm>0.5] = 0.
        
        x = ( Uc*(c-T-s_i*D) + Un*nl )/(1./beta-1)
        x[htm>0.5] = 0.
        b[htm<=0.5] = x[htm<=0.5]/Uc[htm<=0.5]
        b_[htm<=0.5] = x[htm<=0.5]*m[htm<=0.5]
        
        ucP = Uc*(1+Pi)**(-1)
        
        kappa = rho1*ucP
        
        dI = Uc*I*mu*(b+s_i*BD)*Pinv
        dI[htm<=0.5] = 0.
        foc_Pinv = Uc*mu*(b+s_i*BD)/beta
        foc_Pinv[htm<=0.5] = 0.
        foc_BD = mu*Uc*s_i*Pinv/beta
        foc_BD[htm<=0.5] = 0.
        foc_pi = - (1+Pi)**(-2)*rho1*m*Uc/beta - (Lambda+Nu)*psi*Pi 
        foc_pi[htm>0.5] += -Pinv*foc_Pinv[htm>0.5]/(1+Pi)
        
    
        
        
        pihat = UC*Pi*(1+Pi)*psi*np.ones(logm_or_b.shape)
        phillips = -( pihat - beta*pihat -UC*Y*(1-epsilon*(1-W)))
        
        foc_D = ( mu*Uc*s_i - Nu )
        foc_Alpha2 = -rho2
        foc_Alpha2[htm>0.5] += beta*dI[htm>0.5]/Alpha2
        
    #logm_or_b,muhat,e,s_i,htm,c,nl,rho1_,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,x_,kappa_,Epihat_,EdI_
    return np.vstack((
    logm_or_b,muhat,omega,e,s_i,htm,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,foc_Pinv,foc_Pinv,foc_BD,x,kappa,pihat,dI,foc_Pinv,foc_BD
    ))
    
def GSS(YSS,y_i,weights):
    '''
    Aggregate conditions for the steady state
    '''
    global Dbar
    logm_or_b,muhat,omega,e,s_i,htm,c,nl,rho1,rho2,phi,ucP,w_e,foc_pi,foc_Alpha2,foc_D,b,pihat,phillips,dI,m,mu,b_,foc_Pinv,foc_PinvPi,foc_BD,x,kappa,pihat,EdI_,foc_PinvPi_,foc_BD_ = y_i
    Pinv,BD,Eps_MU,Eps_Theta,Kappa,Alpha2,Alpha1_,I,T,Pi,W,Tau,Lambda,Eta,Y,B,UC,Nu,Chi,Xi,D,S,Muhat= YSS
    uc = c**(-sigma)
    
    Dbar = D
    epsilon = epsilonbar
    
    return np.hstack([
    Alpha1_*(1+Pi)-Alpha2,                            #1
    weights.dot(mu*uc),                                                #2
    Eps_MU,                                          #3     
    weights.dot(w_e*nl-c-Gov-psi*Pi**2 /2.),          #4 
    Tau-TauTarget,                         #5
    weights.dot(-rho1/beta - EdI_/Alpha1_),                               #6
    Pi,                             #7 
    Eta,                                             #8 
    weights.dot(Y-(w_e*nl)),                          #9
    weights.dot(B-b),                                #10 
    weights.dot(foc_D),                              #11
    weights.dot(phi*uc*(1-Tau)*w_e +(epsilon)*Kappa*UC*Y-Nu*Y),                 #12   
    weights.dot( UC- uc*s_i),                              #13
    weights.dot(phillips),                           #14  
    Kappa*Y*(1-epsilon*(1-W)) - Chi, #15
    Kappa*UC*(1-epsilon*(1-W)) - Xi + Lambda + Nu*(1-W), #16
    D - ((1-W)*Y - 0.5*psi*Pi**2),                      #17  
    weights.dot(S-s_i),
    weights.dot(Muhat-muhat),
    I - Alpha2/(beta*Alpha1_),
    Eps_Theta
    ])
    
def check_SS(YSS):
    '''
    Checks wether a solution to ss is valid
    '''
    #if (YSS[3] > 1.) | (YSS[3] < -.1):
    if (YSS[5] < TRange[0]) or (YSS[5] > TRange[1]):    
        print 'Out of Transfer Range'
        return False
    else:    
        return True
    
def nomalize(Gamma,weights=None):
    '''
    Normalizes the distriubtion of states if need be
    '''            
    htm = Gamma[:,5]
    nothtm = htm < .5
    if weights is None:
        weights = np.ones(len(Gamma))/len(Gamma)
    Gamma[nothtm,0] -= weights[nothtm].dot(Gamma[nothtm,0])/weights[nothtm].sum()#np.log(weights[nothtm].dot(np.exp(Gamma[nothtm,0]))/weights[nothtm].sum())
    #if Y_target is not None:
    #Gamma[nothtm,1] += (Y_target[-1] - weights.dot(Gamma[:,1]))/weights[nothtm].sum()
    return Gamma
    
    
def check_extreme(z_i):
    return False
    
    